"use strict";
const CustomParameter = require("../../joynr/types/CustomParameter");
const GlobalDiscoveryEntry = require("../../joynr/types/GlobalDiscoveryEntry");
const DiscoveryEntry = require("../../joynr/types/DiscoveryEntry");
const Version = require("../../joynr/types/Version");
const ChangeType = require("../../joynr/types/ChangeType");
const ProviderQos = require("../../joynr/types/ProviderQos");
const DiscoveryError = require("../../joynr/types/DiscoveryError");
const ProviderScope = require("../../joynr/types/ProviderScope");
const ProviderOperation = require("../../../joynr/provider/ProviderOperation");
const ProviderEvent = require("../../../joynr/provider/ProviderEvent");
const JoynrProvider_1 = require("../../../joynr/types/JoynrProvider");
/**
 * PLEASE NOTE. THIS IS A GENERATED FILE!
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>The GlobalCapabilitiesDirectory is a joynr internal interface. The joynr framework
 * uses it to register providers, which are available at a global scope, with the selected
 * backends.
 * Such global providers can be discovered by all cluster controllers which are connected to
 * the same GlobalCapabilitiesDirectory. In contrast, a provider that is available at local
 * scope only is solely registered at its own (local) cluster controller. It can only be
 * discovered by that cluster controller and runtimes connected to that cluster controller.
 * A provider is registered along with parameters which will be used during the arbitration
 * process to select a suitable provider for a proxy. This information is stored in
 * GlobalDiscoveryEntry objects. A provider/GlobalDiscoveryEntry can be registered in multiple
 * global backends, identified by its GBIDs (Global Backend Identifier). The lookup methods
 * always return only one GlobalDiscoveryEntry, i.e. a single GBID, for a provider which is
 * registered in multiple backends. The selection is up to the implementation of the Global
 * Capabilities Directory.
 * The reference to a GBID in the address field of GlobalDiscoveryEntries is not taken into
 * account in the add methods. It is replaced with the correct GBID in the return value of the
 * lookup methods, see description of the lookup methods. To make the add and lookup methods
 * of interface version 0.1 compatible with the new ones in version 0.2, each Global
 * Capabilities Directory instance must be available in only one global backend and it has to
 * know its own GBID.
 * #noVersionGeneration
 * @see GlobalDiscoveryEntry
 */
class GlobalCapabilitiesDirectoryProvider extends JoynrProvider_1.JoynrProvider {
    /**
     * @param [implementation] the implementation of the provider
     * @param [implementation.ATTRIBUTENAME] the definition of attribute implementation
     * @param [implementation.ATTRIBUTENAME.set] the getter function that stores the given attribute value
     * @param [implementation.ATTRIBUTENAME.get] the getter function that returns the current attribute value
     * @param [implementation.OPERATIONNAME] the operation function
     * @param [implementation.EVENTNAME] the definition of the event implementation
     */
    constructor(implementation) {
        super();
        this.interfaceName = "infrastructure/GlobalCapabilitiesDirectory";
        // defining provider members
        this.add = new ProviderOperation(implementation.add, "add", [
            {
                inputParameter: [
                    {
                        name: "globalDiscoveryEntries",
                        type: "joynr.types.GlobalDiscoveryEntry[]"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "globalDiscoveryEntry",
                        type: "joynr.types.GlobalDiscoveryEntry"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "globalDiscoveryEntry",
                        type: "joynr.types.GlobalDiscoveryEntry"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: []
            }
        ]);
        this.lookup = new ProviderOperation(implementation.lookup, "lookup", [
            {
                inputParameter: [
                    {
                        name: "domains",
                        type: "String[]"
                    },
                    {
                        name: "interfaceName",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.GlobalDiscoveryEntry[]"
                    }
                ]
            },
            {
                inputParameter: [
                    {
                        name: "domains",
                        type: "String[]"
                    },
                    {
                        name: "interfaceName",
                        type: "String"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.GlobalDiscoveryEntry[]"
                    }
                ]
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.GlobalDiscoveryEntry"
                    }
                ]
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: [
                    {
                        name: "result",
                        type: "joynr.types.GlobalDiscoveryEntry"
                    }
                ]
            }
        ]);
        this.removeStale = new ProviderOperation(implementation.removeStale, "removeStale", [
            {
                inputParameter: [
                    {
                        name: "clusterControllerId",
                        type: "String"
                    },
                    {
                        name: "maxLastSeenDateMs",
                        type: "Long"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
        this.touch = new ProviderOperation(implementation.touch, "touch", [
            {
                inputParameter: [
                    {
                        name: "clusterControllerId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "clusterControllerId",
                        type: "String"
                    },
                    {
                        name: "participantIds",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
        this.remove = new ProviderOperation(implementation.remove, "remove", [
            {
                inputParameter: [
                    {
                        name: "participantIds",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "gbids",
                        type: "String[]"
                    }
                ],
                error: {
                    type: "joynr.types.DiscoveryError"
                },
                outputParameter: []
            }
        ]);
        this.globalDiscoveryEntryChanged = new ProviderEvent({
            eventName: "globalDiscoveryEntryChanged",
            outputParameterProperties: [
                {
                    name: "typeOfChange",
                    type: "joynr.types.ChangeType"
                },
                {
                    name: "globalDiscoveryEntry",
                    type: "joynr.types.GlobalDiscoveryEntry"
                }
            ],
            selective: false,
            filterSettings: {}
        });
        implementation.globalDiscoveryEntryChanged = this.globalDiscoveryEntryChanged;
    }
    static getUsedJoynrtypes() {
        return [
            CustomParameter,
            GlobalDiscoveryEntry,
            DiscoveryEntry,
            Version,
            ChangeType,
            ProviderQos,
            DiscoveryError,
            ProviderScope
        ];
    }
}
/**
 * The MAJOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
 */
GlobalCapabilitiesDirectoryProvider.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
 */
GlobalCapabilitiesDirectoryProvider.MINOR_VERSION = 3;
module.exports = GlobalCapabilitiesDirectoryProvider;
