import DiscoveryEntry = require("../../joynr/types/DiscoveryEntry");
import DiscoveryEntryWithMetaInfo = require("../../joynr/types/DiscoveryEntryWithMetaInfo");
import DiscoveryQos = require("../../joynr/types/DiscoveryQos");
import ProviderOperation = require("../../../joynr/provider/ProviderOperation");
import { JoynrProvider } from "../../../joynr/types/JoynrProvider";
declare namespace DiscoveryProvider {
    interface DiscoveryProviderImplementation {
        add: AddSignature;
        lookup: LookupSignature;
        addToAll: AddToAllSignature;
        remove: RemoveSignature;
    }
    interface AddArgs1 {
        discoveryEntry: DiscoveryEntry;
    }
    type AddReturns1 = void;
    interface AddArgs2 {
        discoveryEntry: DiscoveryEntry;
        awaitGlobalRegistration: boolean;
    }
    type AddReturns2 = void;
    interface AddArgs3 {
        discoveryEntry: DiscoveryEntry;
        awaitGlobalRegistration: boolean;
        gbids: string[];
    }
    type AddReturns3 = void;
    type AddSignature = ((settings: AddArgs1) => AddReturns1 | Promise<AddReturns1>) & ((settings: AddArgs2) => AddReturns2 | Promise<AddReturns2>) & ((settings: AddArgs3) => AddReturns3 | Promise<AddReturns3>);
    interface LookupArgs1 {
        domains: string[];
        interfaceName: string;
        discoveryQos: DiscoveryQos;
    }
    interface LookupReturns1 {
        result: DiscoveryEntryWithMetaInfo[];
    }
    interface LookupArgs2 {
        domains: string[];
        interfaceName: string;
        discoveryQos: DiscoveryQos;
        gbids: string[];
    }
    interface LookupReturns2 {
        result: DiscoveryEntryWithMetaInfo[];
    }
    interface LookupArgs3 {
        participantId: string;
    }
    interface LookupReturns3 {
        result: DiscoveryEntryWithMetaInfo;
    }
    interface LookupArgs4 {
        participantId: string;
        discoveryQos: DiscoveryQos;
        gbids: string[];
    }
    interface LookupReturns4 {
        result: DiscoveryEntryWithMetaInfo;
    }
    type LookupSignature = ((settings: LookupArgs1) => LookupReturns1 | Promise<LookupReturns1>) & ((settings: LookupArgs2) => LookupReturns2 | Promise<LookupReturns2>) & ((settings: LookupArgs3) => LookupReturns3 | Promise<LookupReturns3>) & ((settings: LookupArgs4) => LookupReturns4 | Promise<LookupReturns4>);
    interface AddToAllArgs1 {
        discoveryEntry: DiscoveryEntry;
        awaitGlobalRegistration: boolean;
    }
    type AddToAllReturns1 = void;
    type AddToAllSignature = ((settings: AddToAllArgs1) => AddToAllReturns1 | Promise<AddToAllReturns1>);
    interface RemoveArgs1 {
        participantId: string;
    }
    type RemoveReturns1 = void;
    type RemoveSignature = ((settings: RemoveArgs1) => RemoveReturns1 | Promise<RemoveReturns1>);
}
/**
 * PLEASE NOTE. THIS IS A GENERATED FILE!
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>The <code>Discovery</code> interface is a joynr internal
 * interface. This interface is used by libjoynr to add, lookup or
 * remove provider to joynr discovery. Internally joynr discovery
 * consists of a centralized discovery directory
 * (<code>GlobalCapabilitiesDirectory</code>) that is distributed to
 * all cluster controller (<code>LocalCapabilitiesDirectory</code>).
 * #noVersionGeneration
 */
declare class DiscoveryProvider extends JoynrProvider {
    interfaceName: string;
    /**
     * @function DiscoveryProvider#add
     * @summary The add operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a provider to the joynr discovery directory.
     * If registration to local and global scope is requested by the registration
     * configuration, the provider is registered to all GBIDs configured in the cluster
     * controller. The global capabilities directory identified by the first GBID
     * performs the registration.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * Provider information and registration configuration
     */
    /**
     * @function DiscoveryProvider#add
     * @summary The add operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a provider to the joynr discovery directory.
     * If registration to local and global scope is requested by the registration
     * configuration, the provider is registered to all GBIDs configured in the cluster
     * controller. The global capabilities directory identified by the first GBID
     * performs the registration.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * Provider information and registration configuration
     * @param {Boolean} settings.awaitGlobalRegistration -
     * if true, the response will be delayed either until
     * global registration succeeded or failed (only applicable to global scope)
     */
    /**
     * @function DiscoveryProvider#add
     * @summary The add operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a provider to the joynr discovery directory.
     * If registration to local and global scope is requested by the registration
     * configuration, the provider is registered to all GBIDs configured in the cluster
     * controller.
     * The 'gbids' parameter can be provided to override the GBIDs selection in the cluster
     * controller. The global capabilities directory identified by the first selected GBID
     * performs the registration.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * Provider information and registration configuration
     * @param {Boolean} settings.awaitGlobalRegistration -
     * if true, the response will be delayed either until
     * global registration succeeded or failed (only applicable to global scope)
     * @param {Array.<String>} settings.gbids -
     * Subset of GBIDs configured in the cluster controller for
     * custom global registration (only applicable to global scope)
     */
    add: ProviderOperation;
    /**
     * @function DiscoveryProvider#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up providers in the joynr discovery that match the requested QoS.
     * In case of global discovery, the lookup will be done for all known backends via the GCD
     * instance in the default backend.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {Array.<String>} settings.domains -
     * the domain to search for provider
     * @param {String} settings.interfaceName -
     * the interface the provider must implement
     * @param {DiscoveryQos} settings.discoveryQos -
     * the QoS used for the lookup
     * @returns {DiscoveryProvider#LookupReturned}
     * 	{Array.<DiscoveryEntryWithMetaInfo>} result
     */
    /**
     * @typedef {Object} DiscoveryProvider#LookupReturned
     * @property {Array.<DiscoveryEntryWithMetaInfo>} result
     * a list of matching providers
     */
    /**
     * @function DiscoveryProvider#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up providers that match the requested QoS in the joynr discovery for
     * specific GBIDs.
     * The global lookup will be done via the GCD instance in the backend identified
     * by the first gbid of the gbids parameter.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {Array.<String>} settings.domains -
     * the domain to search for provider
     * @param {String} settings.interfaceName -
     * the interface the provider must implement
     * @param {DiscoveryQos} settings.discoveryQos -
     * the QoS used for the lookup
     * @param {Array.<String>} settings.gbids -
     * Global Backend IDs for which providers should be returned. Only
     * Providers from the provided Global Backends will be returned.
     * @returns {DiscoveryProvider#LookupReturned}
     * 	{Array.<DiscoveryEntryWithMetaInfo>} result
     */
    /**
     * @typedef {Object} DiscoveryProvider#LookupReturned
     * @property {Array.<DiscoveryEntryWithMetaInfo>} result
     * a list of matching providers
     */
    /**
     * @function DiscoveryProvider#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up a specific provider in the joynr discovery.
     * In case of global discovery, the lookup will be done for all known backends via the GCD
     * instance in the default backend.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the participant ID of the provider to look up
     * @returns {DiscoveryProvider#LookupReturned}
     * 	{DiscoveryEntryWithMetaInfo} result
     */
    /**
     * @typedef {Object} DiscoveryProvider#LookupReturned
     * @property {DiscoveryEntryWithMetaInfo} result
     * the provider matching the participant ID
     */
    /**
     * @function DiscoveryProvider#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up a specific provider in the joynr discovery for specific GBIDs.
     * The global lookup will be done via the GCD instance in the backend identified
     * by the first gbid of the gbids parameter.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the participant ID of the provider to look up
     * @param {DiscoveryQos} settings.discoveryQos -
     * the QoS used for the lookup
     * @param {Array.<String>} settings.gbids -
     * Global Backend IDs for which providers should be returned. Only
     * Providers from the provided Global Backends will be returned.
     * @returns {DiscoveryProvider#LookupReturned}
     * 	{DiscoveryEntryWithMetaInfo} result
     */
    /**
     * @typedef {Object} DiscoveryProvider#LookupReturned
     * @property {DiscoveryEntryWithMetaInfo} result
     * the provider matching the participant ID
     */
    lookup: ProviderOperation;
    /**
     * @function DiscoveryProvider#addToAll
     * @summary The addToAll operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Adds a provider to the joynr discovery directory for all backends
     * known to the cluster controller.
     * The global registration will be done via the GCD instance in the default backend.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * the new DiscoveryEntry to be added
     * @param {Boolean} settings.awaitGlobalRegistration -
     * if true, the response will be delayed either until
     * global registration succeeded or failed
     */
    addToAll: ProviderOperation;
    /**
     * @function DiscoveryProvider#remove
     * @summary The remove operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Removes a provider from joynr discovery.
     * In the case of a provider registered in multiple backends,
     * that provider will be removed from all backends, it was
     * previously registered for.
     * The global remove will be done via the GCD instance in one of the backends in which
     * the provider was registered.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the participant ID of the provider to remove
     */
    remove: ProviderOperation;
    /**
     * @param [implementation] the implementation of the provider
     * @param [implementation.ATTRIBUTENAME] the definition of attribute implementation
     * @param [implementation.ATTRIBUTENAME.set] the getter function that stores the given attribute value
     * @param [implementation.ATTRIBUTENAME.get] the getter function that returns the current attribute value
     * @param [implementation.OPERATIONNAME] the operation function
     * @param [implementation.EVENTNAME] the definition of the event implementation
     */
    constructor(implementation: DiscoveryProvider.DiscoveryProviderImplementation);
    /**
     * The MAJOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static getUsedJoynrtypes(): any[];
}
export = DiscoveryProvider;
