import MessagingQos = require("../../../joynr/messaging/MessagingQos");
import JoynrDiscoveryQos = require("../../../joynr/proxy/DiscoveryQos");
import DiscoveryEntry = require("../../joynr/types/DiscoveryEntry");
import DiscoveryEntryWithMetaInfo = require("../../joynr/types/DiscoveryEntryWithMetaInfo");
import DiscoveryQos = require("../../joynr/types/DiscoveryQos");
declare namespace DiscoveryProxy {
    interface ProxySettings {
        domain: string;
        joynrName: string;
        discoveryQos: JoynrDiscoveryQos;
        messagingQos: MessagingQos | MessagingQos.Settings;
        dependencies: any;
        proxyParticipantId: string;
    }
    interface AddArgs1 {
        discoveryEntry: DiscoveryEntry;
    }
    type AddReturns1 = void;
    interface AddArgs2 {
        discoveryEntry: DiscoveryEntry;
        awaitGlobalRegistration: boolean;
    }
    type AddReturns2 = void;
    interface AddArgs3 {
        discoveryEntry: DiscoveryEntry;
        awaitGlobalRegistration: boolean;
        gbids: string[];
    }
    type AddReturns3 = void;
    type AddSignature = ((settings: AddArgs1) => Promise<AddReturns1>) & ((settings: AddArgs2) => Promise<AddReturns2>) & ((settings: AddArgs3) => Promise<AddReturns3>);
    interface LookupArgs1 {
        domains: string[];
        interfaceName: string;
        discoveryQos: DiscoveryQos;
    }
    interface LookupReturns1 {
        result: DiscoveryEntryWithMetaInfo[];
    }
    interface LookupArgs2 {
        domains: string[];
        interfaceName: string;
        discoveryQos: DiscoveryQos;
        gbids: string[];
    }
    interface LookupReturns2 {
        result: DiscoveryEntryWithMetaInfo[];
    }
    interface LookupArgs3 {
        participantId: string;
    }
    interface LookupReturns3 {
        result: DiscoveryEntryWithMetaInfo;
    }
    interface LookupArgs4 {
        participantId: string;
        discoveryQos: DiscoveryQos;
        gbids: string[];
    }
    interface LookupReturns4 {
        result: DiscoveryEntryWithMetaInfo;
    }
    type LookupSignature = ((settings: LookupArgs1) => Promise<LookupReturns1>) & ((settings: LookupArgs2) => Promise<LookupReturns2>) & ((settings: LookupArgs3) => Promise<LookupReturns3>) & ((settings: LookupArgs4) => Promise<LookupReturns4>);
    interface AddToAllArgs1 {
        discoveryEntry: DiscoveryEntry;
        awaitGlobalRegistration: boolean;
    }
    type AddToAllReturns1 = void;
    type AddToAllSignature = ((settings: AddToAllArgs1) => Promise<AddToAllReturns1>);
    interface RemoveArgs1 {
        participantId: string;
    }
    type RemoveReturns1 = void;
    type RemoveSignature = ((settings: RemoveArgs1) => Promise<RemoveReturns1>);
}
/**
 * @classdesc
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>
 * DiscoveryProxy, generated from the corresponding interface description.
 * <br/><br/>The <code>Discovery</code> interface is a joynr internal
 * interface. This interface is used by libjoynr to add, lookup or
 * remove provider to joynr discovery. Internally joynr discovery
 * consists of a centralized discovery directory
 * (<code>GlobalCapabilitiesDirectory</code>) that is distributed to
 * all cluster controller (<code>LocalCapabilitiesDirectory</code>).
 * #noVersionGeneration
 */
declare class DiscoveryProxy {
    interfaceName: string;
    settings: DiscoveryProxy.ProxySettings;
    domain: string;
    messagingQos: MessagingQos;
    /** set by ProxyBuilder after Arbitration **/
    providerDiscoveryEntry: {
        participantId: string;
    };
    proxyParticipantId: string;
    /**
     * @function DiscoveryProxy#add
     * @summary The add operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a provider to the joynr discovery directory.
     * If registration to local and global scope is requested by the registration
     * configuration, the provider is registered to all GBIDs configured in the cluster
     * controller. The global capabilities directory identified by the first GBID
     * performs the registration.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * Provider information and registration configuration
     */
    /**
     * @function DiscoveryProxy#add
     * @summary The add operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a provider to the joynr discovery directory.
     * If registration to local and global scope is requested by the registration
     * configuration, the provider is registered to all GBIDs configured in the cluster
     * controller. The global capabilities directory identified by the first GBID
     * performs the registration.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * Provider information and registration configuration
     * @param {Boolean} settings.awaitGlobalRegistration -
     * if true, the response will be delayed either until
     * global registration succeeded or failed (only applicable to global scope)
     */
    /**
     * @function DiscoveryProxy#add
     * @summary The add operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a provider to the joynr discovery directory.
     * If registration to local and global scope is requested by the registration
     * configuration, the provider is registered to all GBIDs configured in the cluster
     * controller.
     * The 'gbids' parameter can be provided to override the GBIDs selection in the cluster
     * controller. The global capabilities directory identified by the first selected GBID
     * performs the registration.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * Provider information and registration configuration
     * @param {Boolean} settings.awaitGlobalRegistration -
     * if true, the response will be delayed either until
     * global registration succeeded or failed (only applicable to global scope)
     * @param {Array.<String>} settings.gbids -
     * Subset of GBIDs configured in the cluster controller for
     * custom global registration (only applicable to global scope)
     */
    add: DiscoveryProxy.AddSignature;
    /**
     * @function DiscoveryProxy#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up providers in the joynr discovery that match the requested QoS.
     * In case of global discovery, the lookup will be done for all known backends via the GCD
     * instance in the default backend.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {Array.<String>} settings.domains -
     * the domain to search for provider
     * @param {String} settings.interfaceName -
     * the interface the provider must implement
     * @param {DiscoveryQos} settings.discoveryQos -
     * the QoS used for the lookup
     * @returns {DiscoveryProxy#LookupReturned}
     * 	{Array.<DiscoveryEntryWithMetaInfo>} result
     */
    /**
     * @typedef {Object} DiscoveryProxy#LookupReturned
     * @property {Array.<DiscoveryEntryWithMetaInfo>} result
     * a list of matching providers
     */
    /**
     * @function DiscoveryProxy#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up providers that match the requested QoS in the joynr discovery for
     * specific GBIDs.
     * The global lookup will be done via the GCD instance in the backend identified
     * by the first gbid of the gbids parameter.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {Array.<String>} settings.domains -
     * the domain to search for provider
     * @param {String} settings.interfaceName -
     * the interface the provider must implement
     * @param {DiscoveryQos} settings.discoveryQos -
     * the QoS used for the lookup
     * @param {Array.<String>} settings.gbids -
     * Global Backend IDs for which providers should be returned. Only
     * Providers from the provided Global Backends will be returned.
     * @returns {DiscoveryProxy#LookupReturned}
     * 	{Array.<DiscoveryEntryWithMetaInfo>} result
     */
    /**
     * @typedef {Object} DiscoveryProxy#LookupReturned
     * @property {Array.<DiscoveryEntryWithMetaInfo>} result
     * a list of matching providers
     */
    /**
     * @function DiscoveryProxy#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up a specific provider in the joynr discovery.
     * In case of global discovery, the lookup will be done for all known backends via the GCD
     * instance in the default backend.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the participant ID of the provider to look up
     * @returns {DiscoveryProxy#LookupReturned}
     * 	{DiscoveryEntryWithMetaInfo} result
     */
    /**
     * @typedef {Object} DiscoveryProxy#LookupReturned
     * @property {DiscoveryEntryWithMetaInfo} result
     * the provider matching the participant ID
     */
    /**
     * @function DiscoveryProxy#lookup
     * @summary The lookup operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Looks up a specific provider in the joynr discovery for specific GBIDs.
     * The global lookup will be done via the GCD instance in the backend identified
     * by the first gbid of the gbids parameter.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the participant ID of the provider to look up
     * @param {DiscoveryQos} settings.discoveryQos -
     * the QoS used for the lookup
     * @param {Array.<String>} settings.gbids -
     * Global Backend IDs for which providers should be returned. Only
     * Providers from the provided Global Backends will be returned.
     * @returns {DiscoveryProxy#LookupReturned}
     * 	{DiscoveryEntryWithMetaInfo} result
     */
    /**
     * @typedef {Object} DiscoveryProxy#LookupReturned
     * @property {DiscoveryEntryWithMetaInfo} result
     * the provider matching the participant ID
     */
    lookup: DiscoveryProxy.LookupSignature;
    /**
     * @function DiscoveryProxy#addToAll
     * @summary The addToAll operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Adds a provider to the joynr discovery directory for all backends
     * known to the cluster controller.
     * The global registration will be done via the GCD instance in the default backend.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {DiscoveryEntry} settings.discoveryEntry -
     * the new DiscoveryEntry to be added
     * @param {Boolean} settings.awaitGlobalRegistration -
     * if true, the response will be delayed either until
     * global registration succeeded or failed
     */
    addToAll: DiscoveryProxy.AddToAllSignature;
    /**
     * @function DiscoveryProxy#remove
     * @summary The remove operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Removes a provider from joynr discovery.
     * In the case of a provider registered in multiple backends,
     * that provider will be removed from all backends, it was
     * previously registered for.
     * The global remove will be done via the GCD instance in one of the backends in which
     * the provider was registered.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the participant ID of the provider to remove
     */
    remove: DiscoveryProxy.RemoveSignature;
    /**
     * @param settings the settings object for this function call
     * @param settings.domain the domain name
     * @param settings.joynrName the interface name //TODO: check do we need this?
     *
     * @param settings.discoveryQos the Quality of Service parameters for arbitration
     * @param settings.discoveryQos.discoveryTimeoutMs for rpc calls to wait for arbitration to finish.
     * @param settings.discoveryQos.arbitrationStrategy Strategy for choosing the appropriate provider from the list returned by the capabilities directory
     * @param settings.discoveryQos.cacheMaxAgeMs Maximum age of entries in the localCapabilitiesDirectory. If this value filters out all entries of the local capabilities directory a lookup in the global capabilitiesDirectory will take place.
     * @param settings.discoveryQos.discoveryScope If localOnly is set to true, only local providers will be considered.
     * @param settings.discoveryQos.additionalParameters a map holding additional parameters in the form of key value pairs in the javascript object, e.g.: {"myKey": "myValue", "myKey2": 5}
     *
     * @param settings.messagingQos the Quality of Service parameters for messaging
     * @param settings.messagingQos.ttl Roundtrip timeout for rpc requests.
     * @param settings.dependencies instances of the internal objects needed by the proxy to interface with joynr
     * @param settings.proxyParticipantId unique identifier of the proxy
     */
    constructor(settings: DiscoveryProxy.ProxySettings);
    /**
     * The MAJOR_VERSION of the proxy is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the proxy is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static getUsedJoynrtypes(): any[];
}
export = DiscoveryProxy;
