import WebSocketClientAddress = require("../../joynr/system/RoutingTypes/WebSocketClientAddress");
import BrowserAddress = require("../../joynr/system/RoutingTypes/BrowserAddress");
import WebSocketAddress = require("../../joynr/system/RoutingTypes/WebSocketAddress");
import MqttAddress = require("../../joynr/system/RoutingTypes/MqttAddress");
import ChannelAddress = require("../../joynr/system/RoutingTypes/ChannelAddress");
import UdsAddress = require("../../joynr/system/RoutingTypes/UdsAddress");
import UdsClientAddress = require("../../joynr/system/RoutingTypes/UdsClientAddress");
import BinderAddress = require("../../joynr/system/RoutingTypes/BinderAddress");
import { ProviderReadNotifyAttribute } from "../../../joynr/provider/ProviderAttribute";
import ProviderOperation = require("../../../joynr/provider/ProviderOperation");
import { ProviderReadNotifyAttributeImpl, JoynrProvider } from "../../../joynr/types/JoynrProvider";
declare namespace RoutingProvider {
    interface RoutingProviderImplementation {
        globalAddress: ProviderReadNotifyAttributeImpl<string>;
        replyToAddress: ProviderReadNotifyAttributeImpl<string>;
        addNextHop: AddNextHopSignature;
        resolveNextHop: ResolveNextHopSignature;
        removeNextHop: RemoveNextHopSignature;
        addMulticastReceiver: AddMulticastReceiverSignature;
        removeMulticastReceiver: RemoveMulticastReceiverSignature;
    }
    interface AddNextHopArgs1 {
        participantId: string;
        channelAddress: ChannelAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns1 = void;
    interface AddNextHopArgs2 {
        participantId: string;
        mqttAddress: MqttAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns2 = void;
    interface AddNextHopArgs3 {
        participantId: string;
        browserAddress: BrowserAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns3 = void;
    interface AddNextHopArgs4 {
        participantId: string;
        webSocketAddress: WebSocketAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns4 = void;
    interface AddNextHopArgs5 {
        participantId: string;
        udsAddress: UdsAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns5 = void;
    interface AddNextHopArgs6 {
        participantId: string;
        binderAddress: BinderAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns6 = void;
    interface AddNextHopArgs7 {
        participantId: string;
        webSocketClientAddress: WebSocketClientAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns7 = void;
    interface AddNextHopArgs8 {
        participantId: string;
        udsClientAddress: UdsClientAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns8 = void;
    type AddNextHopSignature = ((settings: AddNextHopArgs1) => AddNextHopReturns1 | Promise<AddNextHopReturns1>) & ((settings: AddNextHopArgs2) => AddNextHopReturns2 | Promise<AddNextHopReturns2>) & ((settings: AddNextHopArgs3) => AddNextHopReturns3 | Promise<AddNextHopReturns3>) & ((settings: AddNextHopArgs4) => AddNextHopReturns4 | Promise<AddNextHopReturns4>) & ((settings: AddNextHopArgs5) => AddNextHopReturns5 | Promise<AddNextHopReturns5>) & ((settings: AddNextHopArgs6) => AddNextHopReturns6 | Promise<AddNextHopReturns6>) & ((settings: AddNextHopArgs7) => AddNextHopReturns7 | Promise<AddNextHopReturns7>) & ((settings: AddNextHopArgs8) => AddNextHopReturns8 | Promise<AddNextHopReturns8>);
    interface ResolveNextHopArgs1 {
        participantId: string;
    }
    interface ResolveNextHopReturns1 {
        resolved: boolean;
    }
    type ResolveNextHopSignature = ((settings: ResolveNextHopArgs1) => ResolveNextHopReturns1 | Promise<ResolveNextHopReturns1>);
    interface RemoveNextHopArgs1 {
        participantId: string;
    }
    type RemoveNextHopReturns1 = void;
    type RemoveNextHopSignature = ((settings: RemoveNextHopArgs1) => RemoveNextHopReturns1 | Promise<RemoveNextHopReturns1>);
    interface AddMulticastReceiverArgs1 {
        multicastId: string;
        subscriberParticipantId: string;
        providerParticipantId: string;
    }
    type AddMulticastReceiverReturns1 = void;
    type AddMulticastReceiverSignature = ((settings: AddMulticastReceiverArgs1) => AddMulticastReceiverReturns1 | Promise<AddMulticastReceiverReturns1>);
    interface RemoveMulticastReceiverArgs1 {
        multicastId: string;
        subscriberParticipantId: string;
        providerParticipantId: string;
    }
    type RemoveMulticastReceiverReturns1 = void;
    type RemoveMulticastReceiverSignature = ((settings: RemoveMulticastReceiverArgs1) => RemoveMulticastReceiverReturns1 | Promise<RemoveMulticastReceiverReturns1>);
}
/**
 * PLEASE NOTE. THIS IS A GENERATED FILE!
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>The <code>Routing</code> interface is a joynr internal
 * interface. joynr uses a hierarchy of <code>MessageRouter</code>s to
 * route messages from source to destination. The <code>Routing</code>
 * interface is used to update routing information between parent and
 * child <code>MessageRouter</code>s.
 * #noVersionGeneration
 */
declare class RoutingProvider extends JoynrProvider {
    interfaceName: string;
    /**
     * @name RoutingProvider#globalAddress
     * @summary The globalAddress attribute is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>global address of cluster-controller
     * used for provider registration. Messages from global
     * to these providers have to be sent to this address.
     */
    globalAddress: ProviderReadNotifyAttribute<string>;
    /**
     * @name RoutingProvider#replyToAddress
     * @summary The replyToAddress attribute is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>global address of cluster-controller
     * used as replyTo address for outgoing requests.
     * Replies from other cluster controllers have to be sent
     * to this address.
     */
    replyToAddress: ProviderReadNotifyAttribute<string>;
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {ChannelAddress} settings.channelAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {MqttAddress} settings.mqttAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {BrowserAddress} settings.browserAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {WebSocketAddress} settings.webSocketAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {UdsAddress} settings.udsAddress -
     * the messaging unix domain socket server address of the next hop
     * towards the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {BinderAddress} settings.binderAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {WebSocketClientAddress} settings.webSocketClientAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProvider#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {UdsClientAddress} settings.udsClientAddress -
     * the messaging unix domain client address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    addNextHop: ProviderOperation;
    /**
     * @function RoutingProvider#resolveNextHop
     * @summary The resolveNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Asks the parent routing table whether it is able to
     * resolve the destination participant ID.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant to resolve
     * @returns {RoutingProvider#ResolveNextHopReturned}
     * 	{Boolean} resolved
     */
    /**
     * @typedef {Object} RoutingProvider#ResolveNextHopReturned
     * @property {Boolean} resolved
     * true, if the participant ID could be resolved
     */
    resolveNextHop: ProviderOperation;
    /**
     * @function RoutingProvider#removeNextHop
     * @summary The removeNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Removes a hop from the parent routing table.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     */
    removeNextHop: ProviderOperation;
    /**
     * @function RoutingProvider#addMulticastReceiver
     * @summary The addMulticastReceiver operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Adds a new receiver via their participant ID to for the
     * identified multicasts.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.multicastId -
     * the multicast ID the receiver is interested in.
     * @param {String} settings.subscriberParticipantId -
     * the participant ID of the receiver.
     * @param {String} settings.providerParticipantId -
     * the participant ID of the provider.
     */
    addMulticastReceiver: ProviderOperation;
    /**
     * @function RoutingProvider#removeMulticastReceiver
     * @summary The removeMulticastReceiver operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Removes a new receiver via their participant ID to for the
     * identified multicasts which was previously added via addMulticastReceiver.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.multicastId -
     * the multicast ID the receiver registered for.
     * @param {String} settings.subscriberParticipantId -
     * the participant ID of the receiver.
     * @param {String} settings.providerParticipantId -
     * the participant ID of the provider.
     */
    removeMulticastReceiver: ProviderOperation;
    /**
     * @param [implementation] the implementation of the provider
     * @param [implementation.ATTRIBUTENAME] the definition of attribute implementation
     * @param [implementation.ATTRIBUTENAME.set] the getter function that stores the given attribute value
     * @param [implementation.ATTRIBUTENAME.get] the getter function that returns the current attribute value
     * @param [implementation.OPERATIONNAME] the operation function
     * @param [implementation.EVENTNAME] the definition of the event implementation
     */
    constructor(implementation: RoutingProvider.RoutingProviderImplementation);
    /**
     * The MAJOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static getUsedJoynrtypes(): any[];
}
export = RoutingProvider;
