"use strict";
const WebSocketClientAddress = require("../../joynr/system/RoutingTypes/WebSocketClientAddress");
const BrowserAddress = require("../../joynr/system/RoutingTypes/BrowserAddress");
const WebSocketAddress = require("../../joynr/system/RoutingTypes/WebSocketAddress");
const WebSocketProtocol = require("../../joynr/system/RoutingTypes/WebSocketProtocol");
const MqttAddress = require("../../joynr/system/RoutingTypes/MqttAddress");
const ChannelAddress = require("../../joynr/system/RoutingTypes/ChannelAddress");
const UdsAddress = require("../../joynr/system/RoutingTypes/UdsAddress");
const Address = require("../../joynr/system/RoutingTypes/Address");
const LocalAddress = require("../../joynr/system/RoutingTypes/LocalAddress");
const UdsClientAddress = require("../../joynr/system/RoutingTypes/UdsClientAddress");
const BinderAddress = require("../../joynr/system/RoutingTypes/BinderAddress");
const ProviderAttribute_1 = require("../../../joynr/provider/ProviderAttribute");
const ProviderOperation = require("../../../joynr/provider/ProviderOperation");
const JoynrProvider_1 = require("../../../joynr/types/JoynrProvider");
/**
 * PLEASE NOTE. THIS IS A GENERATED FILE!
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>The <code>Routing</code> interface is a joynr internal
 * interface. joynr uses a hierarchy of <code>MessageRouter</code>s to
 * route messages from source to destination. The <code>Routing</code>
 * interface is used to update routing information between parent and
 * child <code>MessageRouter</code>s.
 * #noVersionGeneration
 */
class RoutingProvider extends JoynrProvider_1.JoynrProvider {
    /**
     * @param [implementation] the implementation of the provider
     * @param [implementation.ATTRIBUTENAME] the definition of attribute implementation
     * @param [implementation.ATTRIBUTENAME.set] the getter function that stores the given attribute value
     * @param [implementation.ATTRIBUTENAME.get] the getter function that returns the current attribute value
     * @param [implementation.OPERATIONNAME] the operation function
     * @param [implementation.EVENTNAME] the definition of the event implementation
     */
    constructor(implementation) {
        super();
        this.interfaceName = "system/Routing";
        // defining provider members
        this.globalAddress = new ProviderAttribute_1.ProviderReadNotifyAttribute(this, implementation.globalAddress, "globalAddress", "String");
        this.replyToAddress = new ProviderAttribute_1.ProviderReadNotifyAttribute(this, implementation.replyToAddress, "replyToAddress", "String");
        this.addNextHop = new ProviderOperation(implementation.addNextHop, "addNextHop", [
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "channelAddress",
                        type: "joynr.system.RoutingTypes.ChannelAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "mqttAddress",
                        type: "joynr.system.RoutingTypes.MqttAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "browserAddress",
                        type: "joynr.system.RoutingTypes.BrowserAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "webSocketAddress",
                        type: "joynr.system.RoutingTypes.WebSocketAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "udsAddress",
                        type: "joynr.system.RoutingTypes.UdsAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "binderAddress",
                        type: "joynr.system.RoutingTypes.BinderAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "webSocketClientAddress",
                        type: "joynr.system.RoutingTypes.WebSocketClientAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            },
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    },
                    {
                        name: "udsClientAddress",
                        type: "joynr.system.RoutingTypes.UdsClientAddress"
                    },
                    {
                        name: "isGloballyVisible",
                        type: "Boolean"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
        this.resolveNextHop = new ProviderOperation(implementation.resolveNextHop, "resolveNextHop", [
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: [
                    {
                        name: "resolved",
                        type: "Boolean"
                    }
                ]
            }
        ]);
        this.removeNextHop = new ProviderOperation(implementation.removeNextHop, "removeNextHop", [
            {
                inputParameter: [
                    {
                        name: "participantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
        this.addMulticastReceiver = new ProviderOperation(implementation.addMulticastReceiver, "addMulticastReceiver", [
            {
                inputParameter: [
                    {
                        name: "multicastId",
                        type: "String"
                    },
                    {
                        name: "subscriberParticipantId",
                        type: "String"
                    },
                    {
                        name: "providerParticipantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
        this.removeMulticastReceiver = new ProviderOperation(implementation.removeMulticastReceiver, "removeMulticastReceiver", [
            {
                inputParameter: [
                    {
                        name: "multicastId",
                        type: "String"
                    },
                    {
                        name: "subscriberParticipantId",
                        type: "String"
                    },
                    {
                        name: "providerParticipantId",
                        type: "String"
                    }
                ],
                error: {
                    type: "no error enumeration given"
                },
                outputParameter: []
            }
        ]);
    }
    static getUsedJoynrtypes() {
        return [
            WebSocketClientAddress,
            BrowserAddress,
            WebSocketAddress,
            WebSocketProtocol,
            MqttAddress,
            ChannelAddress,
            UdsAddress,
            Address,
            LocalAddress,
            UdsClientAddress,
            BinderAddress
        ];
    }
}
/**
 * The MAJOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
 */
RoutingProvider.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the provider is GENERATED FROM THE INTERFACE DESCRIPTION
 */
RoutingProvider.MINOR_VERSION = 1;
module.exports = RoutingProvider;
