import { ProxyReadNotifyAttribute } from "../../../joynr/proxy/ProxyAttribute";
import MessagingQos = require("../../../joynr/messaging/MessagingQos");
import JoynrDiscoveryQos = require("../../../joynr/proxy/DiscoveryQos");
import WebSocketClientAddress = require("../../joynr/system/RoutingTypes/WebSocketClientAddress");
import BrowserAddress = require("../../joynr/system/RoutingTypes/BrowserAddress");
import WebSocketAddress = require("../../joynr/system/RoutingTypes/WebSocketAddress");
import MqttAddress = require("../../joynr/system/RoutingTypes/MqttAddress");
import ChannelAddress = require("../../joynr/system/RoutingTypes/ChannelAddress");
import UdsAddress = require("../../joynr/system/RoutingTypes/UdsAddress");
import UdsClientAddress = require("../../joynr/system/RoutingTypes/UdsClientAddress");
import BinderAddress = require("../../joynr/system/RoutingTypes/BinderAddress");
declare namespace RoutingProxy {
    interface ProxySettings {
        domain: string;
        joynrName: string;
        discoveryQos: JoynrDiscoveryQos;
        messagingQos: MessagingQos | MessagingQos.Settings;
        dependencies: any;
        proxyParticipantId: string;
    }
    interface AddNextHopArgs1 {
        participantId: string;
        channelAddress: ChannelAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns1 = void;
    interface AddNextHopArgs2 {
        participantId: string;
        mqttAddress: MqttAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns2 = void;
    interface AddNextHopArgs3 {
        participantId: string;
        browserAddress: BrowserAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns3 = void;
    interface AddNextHopArgs4 {
        participantId: string;
        webSocketAddress: WebSocketAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns4 = void;
    interface AddNextHopArgs5 {
        participantId: string;
        udsAddress: UdsAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns5 = void;
    interface AddNextHopArgs6 {
        participantId: string;
        binderAddress: BinderAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns6 = void;
    interface AddNextHopArgs7 {
        participantId: string;
        webSocketClientAddress: WebSocketClientAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns7 = void;
    interface AddNextHopArgs8 {
        participantId: string;
        udsClientAddress: UdsClientAddress;
        isGloballyVisible: boolean;
    }
    type AddNextHopReturns8 = void;
    type AddNextHopSignature = ((settings: AddNextHopArgs1) => Promise<AddNextHopReturns1>) & ((settings: AddNextHopArgs2) => Promise<AddNextHopReturns2>) & ((settings: AddNextHopArgs3) => Promise<AddNextHopReturns3>) & ((settings: AddNextHopArgs4) => Promise<AddNextHopReturns4>) & ((settings: AddNextHopArgs5) => Promise<AddNextHopReturns5>) & ((settings: AddNextHopArgs6) => Promise<AddNextHopReturns6>) & ((settings: AddNextHopArgs7) => Promise<AddNextHopReturns7>) & ((settings: AddNextHopArgs8) => Promise<AddNextHopReturns8>);
    interface ResolveNextHopArgs1 {
        participantId: string;
    }
    interface ResolveNextHopReturns1 {
        resolved: boolean;
    }
    type ResolveNextHopSignature = ((settings: ResolveNextHopArgs1) => Promise<ResolveNextHopReturns1>);
    interface RemoveNextHopArgs1 {
        participantId: string;
    }
    type RemoveNextHopReturns1 = void;
    type RemoveNextHopSignature = ((settings: RemoveNextHopArgs1) => Promise<RemoveNextHopReturns1>);
    interface AddMulticastReceiverArgs1 {
        multicastId: string;
        subscriberParticipantId: string;
        providerParticipantId: string;
    }
    type AddMulticastReceiverReturns1 = void;
    type AddMulticastReceiverSignature = ((settings: AddMulticastReceiverArgs1) => Promise<AddMulticastReceiverReturns1>);
    interface RemoveMulticastReceiverArgs1 {
        multicastId: string;
        subscriberParticipantId: string;
        providerParticipantId: string;
    }
    type RemoveMulticastReceiverReturns1 = void;
    type RemoveMulticastReceiverSignature = ((settings: RemoveMulticastReceiverArgs1) => Promise<RemoveMulticastReceiverReturns1>);
}
/**
 * @classdesc
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>
 * RoutingProxy, generated from the corresponding interface description.
 * <br/><br/>The <code>Routing</code> interface is a joynr internal
 * interface. joynr uses a hierarchy of <code>MessageRouter</code>s to
 * route messages from source to destination. The <code>Routing</code>
 * interface is used to update routing information between parent and
 * child <code>MessageRouter</code>s.
 * #noVersionGeneration
 */
declare class RoutingProxy {
    interfaceName: string;
    settings: RoutingProxy.ProxySettings;
    domain: string;
    messagingQos: MessagingQos;
    /** set by ProxyBuilder after Arbitration **/
    providerDiscoveryEntry: {
        participantId: string;
    };
    proxyParticipantId: string;
    /**
     * @name RoutingProxy#globalAddress
     * @summary The globalAddress attribute is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>global address of cluster-controller
     * used for provider registration. Messages from global
     * to these providers have to be sent to this address.
     */
    globalAddress: ProxyReadNotifyAttribute<string>;
    /**
     * @name RoutingProxy#replyToAddress
     * @summary The replyToAddress attribute is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>global address of cluster-controller
     * used as replyTo address for outgoing requests.
     * Replies from other cluster controllers have to be sent
     * to this address.
     */
    replyToAddress: ProxyReadNotifyAttribute<string>;
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {ChannelAddress} settings.channelAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {MqttAddress} settings.mqttAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {BrowserAddress} settings.browserAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {WebSocketAddress} settings.webSocketAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {UdsAddress} settings.udsAddress -
     * the messaging unix domain socket server address of the next hop
     * towards the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {BinderAddress} settings.binderAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {WebSocketClientAddress} settings.webSocketClientAddress -
     * the messaging address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    /**
     * @function RoutingProxy#addNextHop
     * @summary The addNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/>method overloading: different call semantics possible
     * <br/><br/>Adds a hop to the parent routing table.
     * <br/>
     * The overloaded methods (one for each concrete Address type) is
     * needed since polymorphism is currently not supported by joynr.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     * @param {UdsClientAddress} settings.udsClientAddress -
     * the messaging unix domain client address of the next hop towards
     * the corresponding participant ID
     * @param {Boolean} settings.isGloballyVisible -
     * true, participant is globally visible
     * false, otherwise
     */
    addNextHop: RoutingProxy.AddNextHopSignature;
    /**
     * @function RoutingProxy#resolveNextHop
     * @summary The resolveNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Asks the parent routing table whether it is able to
     * resolve the destination participant ID.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant to resolve
     * @returns {RoutingProxy#ResolveNextHopReturned}
     * 	{Boolean} resolved
     */
    /**
     * @typedef {Object} RoutingProxy#ResolveNextHopReturned
     * @property {Boolean} resolved
     * true, if the participant ID could be resolved
     */
    resolveNextHop: RoutingProxy.ResolveNextHopSignature;
    /**
     * @function RoutingProxy#removeNextHop
     * @summary The removeNextHop operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Removes a hop from the parent routing table.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.participantId -
     * the ID of the target participant
     */
    removeNextHop: RoutingProxy.RemoveNextHopSignature;
    /**
     * @function RoutingProxy#addMulticastReceiver
     * @summary The addMulticastReceiver operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Adds a new receiver via their participant ID to for the
     * identified multicasts.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.multicastId -
     * the multicast ID the receiver is interested in.
     * @param {String} settings.subscriberParticipantId -
     * the participant ID of the receiver.
     * @param {String} settings.providerParticipantId -
     * the participant ID of the provider.
     */
    addMulticastReceiver: RoutingProxy.AddMulticastReceiverSignature;
    /**
     * @function RoutingProxy#removeMulticastReceiver
     * @summary The removeMulticastReceiver operation is GENERATED FROM THE INTERFACE DESCRIPTION
     * <br/><br/>Removes a new receiver via their participant ID to for the
     * identified multicasts which was previously added via addMulticastReceiver.
     *
     * @param {Object} settings the arguments object for this function call
     * @param {String} settings.multicastId -
     * the multicast ID the receiver registered for.
     * @param {String} settings.subscriberParticipantId -
     * the participant ID of the receiver.
     * @param {String} settings.providerParticipantId -
     * the participant ID of the provider.
     */
    removeMulticastReceiver: RoutingProxy.RemoveMulticastReceiverSignature;
    /**
     * @param settings the settings object for this function call
     * @param settings.domain the domain name
     * @param settings.joynrName the interface name //TODO: check do we need this?
     *
     * @param settings.discoveryQos the Quality of Service parameters for arbitration
     * @param settings.discoveryQos.discoveryTimeoutMs for rpc calls to wait for arbitration to finish.
     * @param settings.discoveryQos.arbitrationStrategy Strategy for choosing the appropriate provider from the list returned by the capabilities directory
     * @param settings.discoveryQos.cacheMaxAgeMs Maximum age of entries in the localCapabilitiesDirectory. If this value filters out all entries of the local capabilities directory a lookup in the global capabilitiesDirectory will take place.
     * @param settings.discoveryQos.discoveryScope If localOnly is set to true, only local providers will be considered.
     * @param settings.discoveryQos.additionalParameters a map holding additional parameters in the form of key value pairs in the javascript object, e.g.: {"myKey": "myValue", "myKey2": 5}
     *
     * @param settings.messagingQos the Quality of Service parameters for messaging
     * @param settings.messagingQos.ttl Roundtrip timeout for rpc requests.
     * @param settings.dependencies instances of the internal objects needed by the proxy to interface with joynr
     * @param settings.proxyParticipantId unique identifier of the proxy
     */
    constructor(settings: RoutingProxy.ProxySettings);
    /**
     * The MAJOR_VERSION of the proxy is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the proxy is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static getUsedJoynrtypes(): any[];
}
export = RoutingProxy;
