"use strict";
const Address = require("./Address");
/**
 * This is the generated struct type ChannelAddress: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>Channel Address
 */
class ChannelAddress extends Address {
    /**
     * @param members - an object containing the individual member elements
     * @param members.messagingEndpointUrl - Url of HTTP-based message receiver
     * @param members.channelId - Channel identification
     */
    constructor(members) {
        super(members);
        this._typeName = "joynr.system.RoutingTypes.ChannelAddress";
        if (members) {
            this.messagingEndpointUrl = members.messagingEndpointUrl;
            this.channelId = members.channelId;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.messagingEndpointUrl, "String", "members.messagingEndpointUrl");
        _check(_instance.channelId, "String", "members.channelId");
    }
    static getMemberType(memberName) {
        if (ChannelAddress._memberTypes[memberName] !== undefined) {
            return ChannelAddress._memberTypes[memberName];
        }
    }
}
ChannelAddress._typeName = "joynr.system.RoutingTypes.ChannelAddress";
/**
 * The MAJOR_VERSION of the struct type ChannelAddress is GENERATED FROM THE INTERFACE DESCRIPTION
 */
ChannelAddress.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type ChannelAddress is GENERATED FROM THE INTERFACE DESCRIPTION
 */
ChannelAddress.MINOR_VERSION = 0;
ChannelAddress._memberTypes = {
    messagingEndpointUrl: "String",
    channelId: "String"
};
module.exports = ChannelAddress;
