"use strict";
const Address = require("./Address");
/**
 * This is the generated struct type MqttAddress: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>Mqtt Address
 */
class MqttAddress extends Address {
    /**
     * @param members - an object containing the individual member elements
     * @param members.brokerUri - Mqtt broker uri
     * @param members.topic - MQTT topic identification
     */
    constructor(members) {
        super(members);
        this._typeName = "joynr.system.RoutingTypes.MqttAddress";
        if (members) {
            this.brokerUri = members.brokerUri;
            this.topic = members.topic;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.brokerUri, "String", "members.brokerUri");
        _check(_instance.topic, "String", "members.topic");
    }
    static getMemberType(memberName) {
        if (MqttAddress._memberTypes[memberName] !== undefined) {
            return MqttAddress._memberTypes[memberName];
        }
    }
}
MqttAddress._typeName = "joynr.system.RoutingTypes.MqttAddress";
/**
 * The MAJOR_VERSION of the struct type MqttAddress is GENERATED FROM THE INTERFACE DESCRIPTION
 */
MqttAddress.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type MqttAddress is GENERATED FROM THE INTERFACE DESCRIPTION
 */
MqttAddress.MINOR_VERSION = 0;
MqttAddress._memberTypes = {
    brokerUri: "String",
    topic: "String"
};
module.exports = MqttAddress;
