"use strict";
const LocalAddress = require("./LocalAddress");
/**
 * This is the generated struct type WebSocketAddress: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:38 CET 2022
 * <br/><br/>Websocket address
 */
class WebSocketAddress extends LocalAddress {
    /**
     * @param members - an object containing the individual member elements
     * @param members.protocol - Websocket protocol type
     * @param members.host - Websocket host
     * @param members.port - Websocket port
     * @param members.path - Websocket path
     */
    constructor(members) {
        super(members);
        this._typeName = "joynr.system.RoutingTypes.WebSocketAddress";
        if (members) {
            this.protocol = members.protocol;
            this.host = members.host;
            this.port = members.port;
            this.path = members.path;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.protocol, "WebSocketProtocol", "members.protocol");
        _check(_instance.host, "String", "members.host");
        _check(_instance.port, "Number", "members.port");
        _check(_instance.path, "String", "members.path");
    }
    static getMemberType(memberName) {
        if (WebSocketAddress._memberTypes[memberName] !== undefined) {
            return WebSocketAddress._memberTypes[memberName];
        }
    }
}
WebSocketAddress._typeName = "joynr.system.RoutingTypes.WebSocketAddress";
/**
 * The MAJOR_VERSION of the struct type WebSocketAddress is GENERATED FROM THE INTERFACE DESCRIPTION
 */
WebSocketAddress.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type WebSocketAddress is GENERATED FROM THE INTERFACE DESCRIPTION
 */
WebSocketAddress.MINOR_VERSION = 0;
WebSocketAddress._memberTypes = {
    protocol: "joynr.system.RoutingTypes.WebSocketProtocol",
    host: "String",
    port: "Integer",
    path: "String"
};
module.exports = WebSocketAddress;
