import JoynrCompound = require("../../../joynr/types/JoynrCompound");
import Version = require("./Version");
import ProviderQos = require("./ProviderQos");
declare namespace DiscoveryEntry {
    interface DiscoveryEntryMembers {
        providerVersion: Version;
        domain: string;
        interfaceName: string;
        participantId: string;
        qos: ProviderQos;
        lastSeenDateMs: number;
        expiryDateMs: number;
        publicKeyId: string;
    }
}
/**
 * This is the generated struct type DiscoveryEntry: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>Stores information about a provider instance and is used to communicate
 * capabilities between a cluster controller and a lib-joynr instance.
 */
declare class DiscoveryEntry extends JoynrCompound {
    static _typeName: string;
    _typeName: string;
    /**
     * semantic version information
     */
    providerVersion: Version;
    /**
     * the domain to register the provider with
     */
    domain: string;
    /**
     * the name of the provider interface
     */
    interfaceName: string;
    /**
     * the participant ID of the provider
     */
    participantId: string;
    /**
     * the qos of the provider
     */
    qos: ProviderQos;
    /**
     * the date in millis since epoch when the source for this provider last
     * 			contacted the directory
     */
    lastSeenDateMs: number;
    /**
     * the date in millis since epoch when this entry can be purged from the
     * 			directory and caches
     */
    expiryDateMs: number;
    /**
     * the ID of the public key to be used to encrypt messages to
     * 		this provider
     */
    publicKeyId: string;
    /**
     * @param members - an object containing the individual member elements
     * @param members.providerVersion - semantic version information
     * @param members.domain - the domain to register the provider with
     * @param members.interfaceName - the name of the provider interface
     * @param members.participantId - the participant ID of the provider
     * @param members.qos - the qos of the provider
     * @param members.lastSeenDateMs - the date in millis since epoch when the source for this provider last
     * 			contacted the directory
     * @param members.expiryDateMs - the date in millis since epoch when this entry can be purged from the
     * 			directory and caches
     * @param members.publicKeyId - the ID of the public key to be used to encrypt messages to
     * 		this provider
     */
    constructor(members: DiscoveryEntry.DiscoveryEntryMembers);
    static checkMembers(_instance: DiscoveryEntry, _check: Function): void;
    /**
     * The MAJOR_VERSION of the struct type DiscoveryEntry is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the struct type DiscoveryEntry is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static readonly _memberTypes: Record<string, string>;
    static getMemberType(memberName: string): string | undefined;
}
export = DiscoveryEntry;
