"use strict";
const JoynrCompound = require("../../../joynr/types/JoynrCompound");
/**
 * This is the generated struct type DiscoveryEntry: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>Stores information about a provider instance and is used to communicate
 * capabilities between a cluster controller and a lib-joynr instance.
 */
class DiscoveryEntry extends JoynrCompound {
    /**
     * @param members - an object containing the individual member elements
     * @param members.providerVersion - semantic version information
     * @param members.domain - the domain to register the provider with
     * @param members.interfaceName - the name of the provider interface
     * @param members.participantId - the participant ID of the provider
     * @param members.qos - the qos of the provider
     * @param members.lastSeenDateMs - the date in millis since epoch when the source for this provider last
     * 			contacted the directory
     * @param members.expiryDateMs - the date in millis since epoch when this entry can be purged from the
     * 			directory and caches
     * @param members.publicKeyId - the ID of the public key to be used to encrypt messages to
     * 		this provider
     */
    constructor(members) {
        super();
        this._typeName = "joynr.types.DiscoveryEntry";
        if (members) {
            this.providerVersion = members.providerVersion;
            this.domain = members.domain;
            this.interfaceName = members.interfaceName;
            this.participantId = members.participantId;
            this.qos = members.qos;
            this.lastSeenDateMs = members.lastSeenDateMs;
            this.expiryDateMs = members.expiryDateMs;
            this.publicKeyId = members.publicKeyId;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.providerVersion, "Version", "members.providerVersion");
        _check(_instance.domain, "String", "members.domain");
        _check(_instance.interfaceName, "String", "members.interfaceName");
        _check(_instance.participantId, "String", "members.participantId");
        _check(_instance.qos, "ProviderQos", "members.qos");
        _check(_instance.lastSeenDateMs, "Number", "members.lastSeenDateMs");
        _check(_instance.expiryDateMs, "Number", "members.expiryDateMs");
        _check(_instance.publicKeyId, "String", "members.publicKeyId");
    }
    static getMemberType(memberName) {
        if (DiscoveryEntry._memberTypes[memberName] !== undefined) {
            return DiscoveryEntry._memberTypes[memberName];
        }
    }
}
DiscoveryEntry._typeName = "joynr.types.DiscoveryEntry";
/**
 * The MAJOR_VERSION of the struct type DiscoveryEntry is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryEntry.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type DiscoveryEntry is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryEntry.MINOR_VERSION = 0;
DiscoveryEntry._memberTypes = {
    providerVersion: "joynr.types.Version",
    domain: "String",
    interfaceName: "String",
    participantId: "String",
    qos: "joynr.types.ProviderQos",
    lastSeenDateMs: "Long",
    expiryDateMs: "Long",
    publicKeyId: "String"
};
module.exports = DiscoveryEntry;
