import DiscoveryEntry = require("./DiscoveryEntry");
import Version = require("./Version");
import ProviderQos = require("./ProviderQos");
declare namespace DiscoveryEntryWithMetaInfo {
    interface DiscoveryEntryWithMetaInfoMembers {
        providerVersion: Version;
        domain: string;
        interfaceName: string;
        participantId: string;
        qos: ProviderQos;
        lastSeenDateMs: number;
        expiryDateMs: number;
        publicKeyId: string;
        isLocal: boolean;
    }
}
/**
 * This is the generated struct type DiscoveryEntryWithMetaInfo: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>Used for lookups between libjoynr and a cluster controller. Contains additional information
 */
declare class DiscoveryEntryWithMetaInfo extends DiscoveryEntry {
    static _typeName: string;
    _typeName: string;
    /**
     * Indicates whether a provider is registered at the local cluster controller
     */
    isLocal: boolean;
    /**
     * @param members - an object containing the individual member elements
     * @param members.providerVersion - semantic version information
     * @param members.domain - the domain to register the provider with
     * @param members.interfaceName - the name of the provider interface
     * @param members.participantId - the participant ID of the provider
     * @param members.qos - the qos of the provider
     * @param members.lastSeenDateMs - the date in millis since epoch when the source for this provider last
     * 			contacted the directory
     * @param members.expiryDateMs - the date in millis since epoch when this entry can be purged from the
     * 			directory and caches
     * @param members.publicKeyId - the ID of the public key to be used to encrypt messages to
     * 		this provider
     * @param members.isLocal - Indicates whether a provider is registered at the local cluster controller
     */
    constructor(members: DiscoveryEntryWithMetaInfo.DiscoveryEntryWithMetaInfoMembers);
    static checkMembers(_instance: DiscoveryEntryWithMetaInfo, _check: Function): void;
    /**
     * The MAJOR_VERSION of the struct type DiscoveryEntryWithMetaInfo is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the struct type DiscoveryEntryWithMetaInfo is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static readonly _memberTypes: Record<string, string>;
    static getMemberType(memberName: string): string | undefined;
}
export = DiscoveryEntryWithMetaInfo;
