"use strict";
const DiscoveryEntry = require("./DiscoveryEntry");
/**
 * This is the generated struct type DiscoveryEntryWithMetaInfo: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>Used for lookups between libjoynr and a cluster controller. Contains additional information
 */
class DiscoveryEntryWithMetaInfo extends DiscoveryEntry {
    /**
     * @param members - an object containing the individual member elements
     * @param members.providerVersion - semantic version information
     * @param members.domain - the domain to register the provider with
     * @param members.interfaceName - the name of the provider interface
     * @param members.participantId - the participant ID of the provider
     * @param members.qos - the qos of the provider
     * @param members.lastSeenDateMs - the date in millis since epoch when the source for this provider last
     * 			contacted the directory
     * @param members.expiryDateMs - the date in millis since epoch when this entry can be purged from the
     * 			directory and caches
     * @param members.publicKeyId - the ID of the public key to be used to encrypt messages to
     * 		this provider
     * @param members.isLocal - Indicates whether a provider is registered at the local cluster controller
     */
    constructor(members) {
        super(members);
        this._typeName = "joynr.types.DiscoveryEntryWithMetaInfo";
        if (members) {
            this.isLocal = members.isLocal;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.providerVersion, "Version", "members.providerVersion");
        _check(_instance.domain, "String", "members.domain");
        _check(_instance.interfaceName, "String", "members.interfaceName");
        _check(_instance.participantId, "String", "members.participantId");
        _check(_instance.qos, "ProviderQos", "members.qos");
        _check(_instance.lastSeenDateMs, "Number", "members.lastSeenDateMs");
        _check(_instance.expiryDateMs, "Number", "members.expiryDateMs");
        _check(_instance.publicKeyId, "String", "members.publicKeyId");
        _check(_instance.isLocal, "Boolean", "members.isLocal");
    }
    static getMemberType(memberName) {
        if (DiscoveryEntryWithMetaInfo._memberTypes[memberName] !== undefined) {
            return DiscoveryEntryWithMetaInfo._memberTypes[memberName];
        }
    }
}
DiscoveryEntryWithMetaInfo._typeName = "joynr.types.DiscoveryEntryWithMetaInfo";
/**
 * The MAJOR_VERSION of the struct type DiscoveryEntryWithMetaInfo is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryEntryWithMetaInfo.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type DiscoveryEntryWithMetaInfo is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryEntryWithMetaInfo.MINOR_VERSION = 0;
DiscoveryEntryWithMetaInfo._memberTypes = {
    providerVersion: "joynr.types.Version",
    domain: "String",
    interfaceName: "String",
    participantId: "String",
    qos: "joynr.types.ProviderQos",
    lastSeenDateMs: "Long",
    expiryDateMs: "Long",
    publicKeyId: "String",
    isLocal: "Boolean"
};
module.exports = DiscoveryEntryWithMetaInfo;
