import JoynrEnum = require("../../../joynr/types/JoynrEnum");
declare namespace DiscoveryError {
    type DiscoveryErrorNames = "UNKNOWN_GBID" | "INVALID_GBID" | "NO_ENTRY_FOR_PARTICIPANT" | "NO_ENTRY_FOR_SELECTED_BACKENDS" | "INTERNAL_ERROR";
}
/**
 * This is the generated enum type DiscoveryError: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * Generation date: Tue Dec 06 19:27:39 CET 2022
 * 	* <br/><br/>Modeled error cases for the new add, lookup and remove methods.
 */
declare class DiscoveryError extends JoynrEnum<DiscoveryError.DiscoveryErrorNames> {
    static _typeName: string;
    _typeName: string;
    constructor({ name, value }: {
        name: DiscoveryError.DiscoveryErrorNames;
        value: DiscoveryError.DiscoveryErrorNames | number;
    });
    /**
     * The MAJOR_VERSION of the enum type DiscoveryError is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the enum type DiscoveryError is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    /**
     * <br/><br/>GBID is not known to the Global Capabilities Directory instance.
     */
    static UNKNOWN_GBID: DiscoveryError;
    /**
     * <br/><br/>GBID is invalid, e.g. empty.
     */
    static INVALID_GBID: DiscoveryError;
    /**
     * <br/><br/>No entry for the requested participant ID (lookup, remove).
     */
    static NO_ENTRY_FOR_PARTICIPANT: DiscoveryError;
    /**
     * <br/><br/>At least one matching entry is available but not for the selected backends
     * (lookup, remove).
     */
    static NO_ENTRY_FOR_SELECTED_BACKENDS: DiscoveryError;
    /**
     * <br/><br/>internal error in the Global Capabilities Directory.
     */
    static INTERNAL_ERROR: DiscoveryError;
}
export = DiscoveryError;
