import JoynrCompound = require("../../../joynr/types/JoynrCompound");
import DiscoveryScope = require("./DiscoveryScope");
declare namespace DiscoveryQos {
    interface DiscoveryQosMembers {
        cacheMaxAge: number;
        discoveryTimeout: number;
        discoveryScope: DiscoveryScope;
        providerMustSupportOnChange: boolean;
    }
}
/**
 * This is the generated struct type DiscoveryQos: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>Discovery quality of service settings
 */
declare class DiscoveryQos extends JoynrCompound {
    static _typeName: string;
    _typeName: string;
    /**
     * The maximum age of a cached entry in milliseconds
     */
    cacheMaxAge: number;
    /**
     * Discovery TTL
     */
    discoveryTimeout: number;
    /**
     * The discovery scope: at which level (GLOBAL/LOCAL) should providers be searched.
     */
    discoveryScope: DiscoveryScope;
    /**
     * True, if the provider is required to support the OnChange publication
     */
    providerMustSupportOnChange: boolean;
    /**
     * @param members - an object containing the individual member elements
     * @param members.cacheMaxAge - The maximum age of a cached entry in milliseconds
     * @param members.discoveryTimeout - Discovery TTL
     * @param members.discoveryScope - The discovery scope: at which level (GLOBAL/LOCAL) should providers be searched.
     * @param members.providerMustSupportOnChange - True, if the provider is required to support the OnChange publication
     */
    constructor(members: DiscoveryQos.DiscoveryQosMembers);
    static checkMembers(_instance: DiscoveryQos, _check: Function): void;
    /**
     * The MAJOR_VERSION of the struct type DiscoveryQos is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the struct type DiscoveryQos is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static readonly _memberTypes: Record<string, string>;
    static getMemberType(memberName: string): string | undefined;
}
export = DiscoveryQos;
