"use strict";
const JoynrCompound = require("../../../joynr/types/JoynrCompound");
/**
 * This is the generated struct type DiscoveryQos: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>Discovery quality of service settings
 */
class DiscoveryQos extends JoynrCompound {
    /**
     * @param members - an object containing the individual member elements
     * @param members.cacheMaxAge - The maximum age of a cached entry in milliseconds
     * @param members.discoveryTimeout - Discovery TTL
     * @param members.discoveryScope - The discovery scope: at which level (GLOBAL/LOCAL) should providers be searched.
     * @param members.providerMustSupportOnChange - True, if the provider is required to support the OnChange publication
     */
    constructor(members) {
        super();
        this._typeName = "joynr.types.DiscoveryQos";
        if (members) {
            this.cacheMaxAge = members.cacheMaxAge;
            this.discoveryTimeout = members.discoveryTimeout;
            this.discoveryScope = members.discoveryScope;
            this.providerMustSupportOnChange = members.providerMustSupportOnChange;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.cacheMaxAge, "Number", "members.cacheMaxAge");
        _check(_instance.discoveryTimeout, "Number", "members.discoveryTimeout");
        _check(_instance.discoveryScope, "DiscoveryScope", "members.discoveryScope");
        _check(_instance.providerMustSupportOnChange, "Boolean", "members.providerMustSupportOnChange");
    }
    static getMemberType(memberName) {
        if (DiscoveryQos._memberTypes[memberName] !== undefined) {
            return DiscoveryQos._memberTypes[memberName];
        }
    }
}
DiscoveryQos._typeName = "joynr.types.DiscoveryQos";
/**
 * The MAJOR_VERSION of the struct type DiscoveryQos is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryQos.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type DiscoveryQos is GENERATED FROM THE INTERFACE DESCRIPTION
 */
DiscoveryQos.MINOR_VERSION = 0;
DiscoveryQos._memberTypes = {
    cacheMaxAge: "Long",
    discoveryTimeout: "Long",
    discoveryScope: "joynr.types.DiscoveryScope",
    providerMustSupportOnChange: "Boolean"
};
module.exports = DiscoveryQos;
