import JoynrEnum = require("../../../joynr/types/JoynrEnum");
declare namespace DiscoveryScope {
    type DiscoveryScopeNames = "LOCAL_ONLY" | "LOCAL_THEN_GLOBAL" | "LOCAL_AND_GLOBAL" | "GLOBAL_ONLY";
}
/**
 * This is the generated enum type DiscoveryScope: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * Generation date: Tue Dec 06 19:27:39 CET 2022
 * 	* <br/><br/>Enumeration specifying the discovery scope choices
 */
declare class DiscoveryScope extends JoynrEnum<DiscoveryScope.DiscoveryScopeNames> {
    static _typeName: string;
    _typeName: string;
    constructor({ name, value }: {
        name: DiscoveryScope.DiscoveryScopeNames;
        value: DiscoveryScope.DiscoveryScopeNames | number;
    });
    /**
     * The MAJOR_VERSION of the enum type DiscoveryScope is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the enum type DiscoveryScope is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    /**
     * <br/><br/>Consider only locally registered providers.
     */
    static LOCAL_ONLY: DiscoveryScope;
    /**
     * <br/><br/>Consider only locally registered providers, if no results are found,
     * query global cache as well. If no results are found in cache, query global capabilities
     * directory.
     */
    static LOCAL_THEN_GLOBAL: DiscoveryScope;
    /**
     * <br/><br/>Consider both locally registered providers and globally ones. If no
     * results are found in cache, query global capabilities directory.
     */
    static LOCAL_AND_GLOBAL: DiscoveryScope;
    /**
     * <br/><br/>Consider only globally registered providers. If no results are found
     * in cache, query global capabilities directory.
     */
    static GLOBAL_ONLY: DiscoveryScope;
}
export = DiscoveryScope;
