import DiscoveryEntry = require("./DiscoveryEntry");
import Version = require("./Version");
import ProviderQos = require("./ProviderQos");
declare namespace GlobalDiscoveryEntry {
    interface GlobalDiscoveryEntryMembers {
        providerVersion: Version;
        domain: string;
        interfaceName: string;
        participantId: string;
        qos: ProviderQos;
        lastSeenDateMs: number;
        expiryDateMs: number;
        publicKeyId: string;
        address: string;
    }
}
/**
 * This is the generated struct type GlobalDiscoveryEntry: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>GlobalDiscoveryEntry stores information about a provider instance and extends
 * DiscoveryEntry by adding transport middleware specific address information.
 * GlobalDiscoveryEntry objects are used to register a new provider instance with the backend.
 * In addition, objects of GlobalDiscoveryEntry will be returned by the backend during the
 * arbitration process in order to select a suitable provider for a proxy.
 * @see DiscoveryEntry
 */
declare class GlobalDiscoveryEntry extends DiscoveryEntry {
    static _typeName: string;
    _typeName: string;
    /**
     * the serialized transport-middleware-specific address where the provider can
     * 			be reached. The address is a subclass of <code>Address</code> and is stored as a JSON string.
     */
    address: string;
    /**
     * @param members - an object containing the individual member elements
     * @param members.providerVersion - semantic version information
     * @param members.domain - the domain to register the provider with
     * @param members.interfaceName - the name of the provider interface
     * @param members.participantId - the participant ID of the provider
     * @param members.qos - the qos of the provider
     * @param members.lastSeenDateMs - the date in millis since epoch when the source for this provider last
     * 			contacted the directory
     * @param members.expiryDateMs - the date in millis since epoch when this entry can be purged from the
     * 			directory and caches
     * @param members.publicKeyId - the ID of the public key to be used to encrypt messages to
     * 		this provider
     * @param members.address - the serialized transport-middleware-specific address where the provider can
     * 			be reached. The address is a subclass of <code>Address</code> and is stored as a JSON string.
     */
    constructor(members: GlobalDiscoveryEntry.GlobalDiscoveryEntryMembers);
    static checkMembers(_instance: GlobalDiscoveryEntry, _check: Function): void;
    /**
     * The MAJOR_VERSION of the struct type GlobalDiscoveryEntry is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the struct type GlobalDiscoveryEntry is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static readonly _memberTypes: Record<string, string>;
    static getMemberType(memberName: string): string | undefined;
}
export = GlobalDiscoveryEntry;
