import JoynrCompound = require("../../../joynr/types/JoynrCompound");
import CustomParameter = require("./CustomParameter");
import ProviderScope = require("./ProviderScope");
declare namespace ProviderQos {
    interface ProviderQosMembers {
        customParameters: CustomParameter[];
        priority: number;
        scope: ProviderScope;
        supportsOnChangeSubscriptions: boolean;
    }
}
/**
 * This is the generated struct type ProviderQos: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>the provider quality of service settings
 */
declare class ProviderQos extends JoynrCompound {
    static _typeName: string;
    _typeName: string;
    /**
     * the list of Provider-Specific and InterfaceSpecific
     * 				QoS Parameters
     */
    customParameters: CustomParameter[];
    /**
     * the priority value of the provider used for discovery
     */
    priority: number;
    /**
     * the scope of the provider (e.g. if it is to be used only
     * 			with the local cluster controller)
     */
    scope: ProviderScope;
    /**
     * true, if the provider supports onChangeSubscriptions,
     * 			false otherwise
     */
    supportsOnChangeSubscriptions: boolean;
    /**
     * @param members - an object containing the individual member elements
     * @param members.customParameters - the list of Provider-Specific and InterfaceSpecific
     * 				QoS Parameters
     * @param members.priority - the priority value of the provider used for discovery
     * @param members.scope - the scope of the provider (e.g. if it is to be used only
     * 			with the local cluster controller)
     * @param members.supportsOnChangeSubscriptions - true, if the provider supports onChangeSubscriptions,
     * 			false otherwise
     */
    constructor(members: ProviderQos.ProviderQosMembers);
    static checkMembers(_instance: ProviderQos, _check: Function): void;
    /**
     * The MAJOR_VERSION of the struct type ProviderQos is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MAJOR_VERSION: number;
    /**
     * The MINOR_VERSION of the struct type ProviderQos is GENERATED FROM THE INTERFACE DESCRIPTION
     */
    static MINOR_VERSION: number;
    static readonly _memberTypes: Record<string, string>;
    static getMemberType(memberName: string): string | undefined;
}
export = ProviderQos;
