"use strict";
const JoynrCompound = require("../../../joynr/types/JoynrCompound");
/**
 * This is the generated struct type ProviderQos: DOCS GENERATED FROM INTERFACE DESCRIPTION
 * <br/>Generation date: Tue Dec 06 19:27:39 CET 2022
 * <br/><br/>the provider quality of service settings
 */
class ProviderQos extends JoynrCompound {
    /**
     * @param members - an object containing the individual member elements
     * @param members.customParameters - the list of Provider-Specific and InterfaceSpecific
     * 				QoS Parameters
     * @param members.priority - the priority value of the provider used for discovery
     * @param members.scope - the scope of the provider (e.g. if it is to be used only
     * 			with the local cluster controller)
     * @param members.supportsOnChangeSubscriptions - true, if the provider supports onChangeSubscriptions,
     * 			false otherwise
     */
    constructor(members) {
        super();
        this._typeName = "joynr.types.ProviderQos";
        if (members) {
            this.customParameters = members.customParameters;
            this.priority = members.priority;
            this.scope = members.scope;
            this.supportsOnChangeSubscriptions = members.supportsOnChangeSubscriptions;
        }
    }
    static checkMembers(_instance, _check) {
        _check(_instance.customParameters, "Array", "members.customParameters");
        _check(_instance.priority, "Number", "members.priority");
        _check(_instance.scope, "ProviderScope", "members.scope");
        _check(_instance.supportsOnChangeSubscriptions, "Boolean", "members.supportsOnChangeSubscriptions");
    }
    static getMemberType(memberName) {
        if (ProviderQos._memberTypes[memberName] !== undefined) {
            return ProviderQos._memberTypes[memberName];
        }
    }
}
ProviderQos._typeName = "joynr.types.ProviderQos";
/**
 * The MAJOR_VERSION of the struct type ProviderQos is GENERATED FROM THE INTERFACE DESCRIPTION
 */
ProviderQos.MAJOR_VERSION = 0;
/**
 * The MINOR_VERSION of the struct type ProviderQos is GENERATED FROM THE INTERFACE DESCRIPTION
 */
ProviderQos.MINOR_VERSION = 0;
ProviderQos._memberTypes = {
    customParameters: "joynr.types.CustomParameter[]",
    priority: "Long",
    scope: "joynr.types.ProviderScope",
    supportsOnChangeSubscriptions: "Boolean"
};
module.exports = ProviderQos;
