import { Persistency, PersistencySettings } from "./interface/Persistency";
declare class LocalStorage implements Persistency {
    /**
     * constructor for a localStorage object
     * @param settings the settings object
     * @param settings.clearPersistency localStorage is cleared if set to true
     */
    constructor(settings: PersistencySettings);
    setItem(key: string, value: any): void;
    getItem(key: string): any;
    removeItem(key: string): void;
    clear(): void;
    init(): Promise<void>;
    shutdown(): Promise<void>;
}
export = LocalStorage;
