"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
/*
 * #%L
 * %%
 * Copyright (C) 2019 BMW Car IT GmbH
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
const Typing = __importStar(require("../joynr/util/Typing"));
class LocalStorage {
    /**
     * constructor for a localStorage object
     * @param settings the settings object
     * @param settings.clearPersistency localStorage is cleared if set to true
     */
    constructor(settings) {
        settings = settings || {};
        Typing.checkPropertyIfDefined(settings.clearPersistency, "Boolean", "settings.clearPersistency");
        if (settings.clearPersistency) {
            localStorage.clear();
        }
    }
    setItem(key, value) {
        localStorage.setItem(key, value);
    }
    getItem(key) {
        return localStorage.getItem(key);
    }
    removeItem(key) {
        localStorage.removeItem(key);
    }
    clear() {
        localStorage.clear();
    }
    init() {
        return Promise.resolve();
    }
    shutdown() {
        return Promise.resolve();
    }
}
module.exports = LocalStorage;
