import { Persistency, PersistencySettings } from "./interface/Persistency";
declare class LocalStorageWrapper implements Persistency {
    private settings;
    private promiseChain;
    private map;
    private storage;
    /**
     * LocalStorage constructor (node wrapper for LocalStorage)
     * @constructor LocalStorageWrapper
     * @classdesc node wrapper for LocalStorage
     *
     * @param settings the settings object
     * @param settings.clearPersistency localStorage is cleared if set to true
     * @param settings.location optional, passed on to node-persist LocalStorage constructor
     */
    constructor(settings: PersistencySettings);
    setItem(key: string, value: any): void;
    getItem(key: string): any;
    removeItem(key: string): void;
    clear(): void;
    init(): Promise<void>;
    shutdown(): Promise<void>;
    private wrapFunction;
}
export = LocalStorageWrapper;
