"use strict";
class MemoryStorage {
    /**
     * MemoryStorage has the same Interface as LocalStorage and is used when persistency is disabled,
     * but the logic relies on the persistency.
     * @constructor
     */
    constructor() {
        this.map = {};
        // do nothing
    }
    setItem(key, value) {
        this.map[key] = value;
    }
    getItem(key) {
        return this.map[key];
    }
    removeItem(key) {
        delete this.map[key];
    }
    clear() {
        this.map = {};
    }
}
module.exports = MemoryStorage;
