import { Persistency } from "../../global/interface/Persistency";
import { JoynrProvider } from "../types/JoynrProvider";
declare class ParticipantIdStorage {
    private createUniqueId;
    private persistency;
    /**
     * @constructor
     *
     * @param persistency - the persistence object to be used to store the participantIds
     * @param createUniqueId - a function generating a unique string
     */
    constructor(persistency: Persistency, createUniqueId: () => string);
    /**
     * @param domain
     * @param provider
     * @param provider.interfaceName
     *
     * @returns the retrieved or generated participantId
     */
    getParticipantId(domain: string, provider: JoynrProvider): string;
    /**
     * @param domain
     * @param provider
     * @param provider.interfaceName
     * @param participantId
     */
    setParticipantId(domain: string, provider: JoynrProvider, participantId: string): void;
}
export = ParticipantIdStorage;
