import DiscoveryProxy from "../../../generated/joynr/system/DiscoveryProxy";
import * as DiscoveryEntry from "../../../generated/joynr/types/DiscoveryEntry";
import * as DiscoveryEntryWithMetaInfo from "../../../generated/joynr/types/DiscoveryEntryWithMetaInfo";
import * as DiscoveryQos from "../../../generated/joynr/types/DiscoveryQos";
import { DiscoveryStub } from "../interface/DiscoveryStub";
declare class LocalDiscoveryAggregator implements DiscoveryStub {
    private discoveryProxy;
    private defaultMessagingQos;
    private epsilonMs;
    constructor();
    setDiscoveryProxy(discoveryProxy: DiscoveryProxy): void;
    private setDiscoveryProxyTtl;
    private restoreDefaultMessagingQos;
    lookupByParticipantId(participantId: string, discoveryQos: DiscoveryQos, gbids: string[]): Promise<DiscoveryEntryWithMetaInfo>;
    lookup(domains: string[], interfaceName: string, discoveryQos: DiscoveryQos, gbids: string[]): Promise<DiscoveryEntryWithMetaInfo[]>;
    add(discoveryEntry: DiscoveryEntry, awaitGlobalRegistration: boolean, gbids: string[]): Promise<void>;
    addToAll(discoveryEntry: DiscoveryEntry, awaitGlobalRegistration: boolean): Promise<void>;
    remove(participantId: string): Promise<void>;
}
export = LocalDiscoveryAggregator;
