declare class SubscriptionListener {
    /**
     * Is called if publication is missed or an error occurs
     * @name SubscriptionListener#onError
     */
    onError?: Function;
    /**
     * Is called if publication is received
     * @name SubscriptionListener#onReceive
     */
    onReceive: Function;
    /**
     * Is called if subscription request has been successfully delivered to the provider
     * @name SubscriptionListener#onSubscribed
     */
    onSubscribed?: Function;
    /**
     * @constructor
     *
     * @param settings.onReceive The function to call when a publication is received
     * @param settings.onError The function to call if no publication is received in the given alert interval
     *            or if some other error occurs. The error is passed as parameter.
     */
    constructor(settings: {
        onReceive: Function;
        onError?: Function;
        onSubscribed?: Function;
    });
}
export = SubscriptionListener;
