/**
 * @param subscriptions - Map containing the subscriptions to be serialized
 *
 * @returns serialized subscriptions
 */
export declare function serializeSubscriptions(subscriptions: Record<string, any>): string;
/**
 * @param subscriptions - Map containing the subscriptions to be serialized
 *
 * @returns serialized subscriptionIds
 */
export declare function serializeSubscriptionIds(subscriptions: Record<string, any>): string;
/**
 * @param subscriptions - serialized subscriptions as String
 *
 * @returns deserialized subscriptions as Map
 */
export declare function deserializeSubscriptions(subscriptions: string): Record<string, any>;
/**
 * @param subscriptions - serialized subscriptions as String
 *
 * @returns deserialized subscriptionIds as Array of String
 */
export declare function deserializeSubscriptionIds(subscriptions: string): string[];
/**
 * @param expectedFilterParameters - the expected filter parameters of a broadcast subscription
 * @param actualFilterParameters - the actual filter parameters of a broadcast subscription
 * @param broadcastName - the name of the checked broadcast
 *
 * @returns an object containing possible caughtErrors if the actualFilterParameters do not match
 *                   the expected filter parameters
 */
export declare function checkFilterParameters(expectedFilterParameters: Record<string, any>, actualFilterParameters: Record<string, any>, broadcastName: string): {
    caughtErrors: string[];
};
/**
 * @param providerParticipantId - provider's participant ID
 * @param multicastName - the name of the multicasts
 * @param partitions - partitions of this multicast
 */
export declare function createMulticastId(providerParticipantId: string, multicastName: string, partitions?: any[]): string;
export declare const VALID_PARTITION_REGEX: RegExp;
export declare const SINGLE_POSITION_WILDCARD = "+";
export declare const MULTI_LEVEL_WILDCARD = "*";
/**
 * validates if the provided partitions for multicast publications only contains valid characters
 * @param partitions
 * @throws {Error} if partitions contains invalid characters
 */
export declare function validatePartitions(partitions?: string[]): void;
