"use strict";
class SubscriptionInformation {
    constructor(subscriptionType, proxyParticipantId, providerParticipantId, request) {
        this._typeName = "joynr.SubscriptionInformation";
        this.subscriptionType = subscriptionType;
        this.proxyParticipantId = proxyParticipantId;
        this.providerParticipantId = providerParticipantId;
        this.subscriptionId = request.subscriptionId;
        this.subscribedToName = request.subscribedToName;
        this.qos = request.qos;
        if (subscriptionType === SubscriptionInformation.SUBSCRIPTION_TYPE_MULTICAST) {
            this.multicastId = request.multicastId;
        }
        else {
            this.lastPublication = 0;
            if (subscriptionType === SubscriptionInformation.SUBSCRIPTION_TYPE_BROADCAST) {
                this.filterParameters = request.filterParameters;
            }
        }
        /*
         * the following members may contain native timer objects, which cannot
         * be serialized via JSON.stringify(), hence they must be excluded
         */
        Object.defineProperty(this, "endDateTimeout", {
            enumerable: false,
            configurable: false,
            writable: true,
            value: undefined
        });
        Object.defineProperty(this, "subscriptionInterval", {
            enumerable: false,
            configurable: false,
            writable: true,
            value: undefined
        });
    }
}
SubscriptionInformation.SUBSCRIPTION_TYPE_MULTICAST = "subscription_type_multicast";
SubscriptionInformation.SUBSCRIPTION_TYPE_BROADCAST = "subscription_type_broadcast";
SubscriptionInformation.SUBSCRIPTION_TYPE_ATTRIBUTE = "subscription_type_attribute";
module.exports = SubscriptionInformation;
