import JoynrException from "./JoynrException";
interface ErrorEnum {
    name: string;
    value: string | number;
}
declare class ApplicationException extends JoynrException {
    error: any;
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of ApplicationException object used for reporting
     * error conditions from method implementations. The settings.error
     * object must be filled with _typeName and name as serialization
     * of an enum object of the matching error enum type defined in
     * Franca.
     *
     * @param [settings] the settings object for the constructor call
     * @param settings.error the error enum to be reported
     * @param [settings.detailMessage] message containing details about the error
     */
    constructor(settings: {
        detailMessage: string;
        error?: ErrorEnum;
    });
    static _typeName: string;
}
export = ApplicationException;
