import JoynrRuntimeException from "./JoynrRuntimeException";
declare class IllegalAccessException extends JoynrRuntimeException {
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of IllegalAccessException object used for reporting
     * error conditions due to access restrictions that should be reported
     * back to consumer side.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.detailMessage] message containing details
     *            about the error
     */
    constructor(settings: {
        detailMessage: string;
    });
    static _typeName: string;
}
export = IllegalAccessException;
