declare class JoynrException extends Error {
    detailMessage: string;
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of JoynrException object used for reporting
     * error conditions. This serves as base class for the underlying
     * ApplicationException and JoynrRuntimeException.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.detailMessage] message containing details about the error
     */
    constructor(settings: {
        detailMessage: string;
    });
    static _typeName: string;
}
export = JoynrException;
