import JoynrException from "./JoynrException";
declare class JoynrRuntimeException extends JoynrException {
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of JoynrRuntimeException object used for reporting
     * error conditions. This serves as super class for other more specific
     * runtime exception objects and inherits from JoynrException.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.detailMessage] message containing details about the error
     */
    constructor(settings: {
        detailMessage: string;
    });
    static _typeName: string;
}
export = JoynrRuntimeException;
