import Version from "../../generated/joynr/types/Version";
import JoynrRuntimeException from "./JoynrRuntimeException";
declare class MethodInvocationException extends JoynrRuntimeException {
    name: string;
    /**
     * The provider version information
     */
    providerVersion?: Version;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of MethodInvocationException object used for reporting
     * error conditions when invoking a method (e.g. method does not
     * exist or no method with matching signature found etc.) that should
     * be transmitted back to consumer side.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.providerVersion] the version of the provider
     *            which could not handle the method invocation
     * @param [settings.detailMessage] message containing details about the error
     */
    constructor(settings: {
        providerVersion?: Version;
        detailMessage: string;
    });
    static _typeName: string;
}
export = MethodInvocationException;
