import Version from "../../generated/joynr/types/Version";
import DiscoveryException from "./DiscoveryException";
declare class NoCompatibleProviderFoundException extends DiscoveryException {
    interfaceName: string;
    discoveredVersions: Version[];
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of NoCompatibleProviderFoundException object used for reporting
     * error conditions during discovery and arbitration when only providers
     * with incompatible versions are found. At least one such provider must
     * have been found, otherwise DiscoveryException will be used.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.detailMessage] message containing details
     *            about the error
     * @param [settings.interfaceName] the name of the interface
     * @param [settings.discoveredVersions] list of discovered but incompatible provider versions
     */
    constructor(settings: {
        detailMessage: string;
        interfaceName: string;
        discoveredVersions: Version[];
    });
    static _typeName: string;
}
export = NoCompatibleProviderFoundException;
