import JoynrRuntimeException from "./JoynrRuntimeException";
declare class ProviderRuntimeException extends JoynrRuntimeException {
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of ProviderRuntimeException object used for reporting
     * generic error conditions on the provider side that should be
     * transmitted back to consumer side.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.detailMessage] message containing details about the error
     */
    constructor(settings: {
        detailMessage: string;
    });
    static _typeName: string;
}
export = ProviderRuntimeException;
