import JoynrRuntimeException from "./JoynrRuntimeException";
declare class PublicationMissedException extends JoynrRuntimeException {
    subscriptionId: string;
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of PublicationMissedException object used to report
     * when a publication has not been received within the expected
     * time period.
     *
     * @param [settings] the settings object for the constructor call
     * @param [settings.detailMessage] message containing details
     *            about the error
     * @param [settings.subscriptionId] the id of the subscription
     */
    constructor(settings: {
        detailMessage: string;
        subscriptionId: string;
    });
    static _typeName: string;
}
export = PublicationMissedException;
