import JoynrRuntimeException from "./JoynrRuntimeException";
declare class SubscriptionException extends JoynrRuntimeException {
    subscriptionId: string;
    name: string;
    /**
     * Used for serialization.
     */
    _typeName: string;
    /**
     * Constructor of SubscriptionException object used for reporting
     * error conditions when creating a subscription (e.g. the
     * provided subscription parameters are not correct etc.) that should
     * be transmitted back to consumer side.
     *
     * @param settings - the settings object for the constructor call
     * @param [settings.detailMessage] message containing details
     *            about the error
     * @param settings.subscriptionId - Id of the subscription
     */
    constructor(settings: {
        detailMessage: string;
        subscriptionId: string;
    });
    static _typeName: string;
}
export = SubscriptionException;
