export interface NORMAL {
    name: "Normal";
    value: "NORMAL";
}
/**
 * Normal effort means that the messaging system will guarantee delivery of the message, including temporarily
 * persisting the message as necessary if the receiver is not currently online. Also known as 'at least once'.
 */
export declare const NORMAL: NORMAL;
export interface BEST_EFFORT {
    name: "Best effort";
    value: "BEST_EFFORT";
}
/**
 * Best effort means that the messaging system will ensure the message is sent out, but will not guarantee that
 * it is received, also meaning the message is not persisted awaiting delivery if the receiver is not currently
 * online. Also known as 'at most once' or 'fire and forget'.
 */
export declare const BEST_EFFORT: BEST_EFFORT;
/**
 * Helper method to allow checking a value to see if it is a valid member of this enum.
 */
export declare function isValid(value: any): boolean;
export declare type effort = NORMAL | BEST_EFFORT;
