import Address = require("../../generated/joynr/system/RoutingTypes/Address");
interface InternalMessagingStubFactory {
    build(address: Address): MessagingStub;
}
declare type MessagingStub = any;
declare class MessagingStubFactory {
    private messagingStubFactories;
    /**
     * @constructor
     *
     * @param settings
     * @param settings.messagingStubFactories a hash mapping addresses to the equivalent message sender
     * @param settings.messagingStubFactories.KEY the key of the map is the className of the address provided in createMessagingStub, the value is the concrete MessagingStubFactory
     * @param settings.messagingStubFactories.KEY.build the factory method of the
     */
    constructor(settings: {
        messagingStubFactories: Record<string, InternalMessagingStubFactory>;
    });
    /**
     * @param address the address to create a messaging stub for
     */
    createMessagingStub(address: Address): void;
}
export = MessagingStubFactory;
