import WebMessagingSkeleton = require("../webmessaging/WebMessagingSkeleton");
declare class BrowserMessagingSkeleton {
    receiverCallbacks: any;
    private log;
    /**
     * @constructor BrowserMessagingSkeleton
     *
     * @param settings
     * @param settings.webMessagingSkeleton a web messaging skeleton receiving web messages
     */
    constructor(settings: {
        webMessagingSkeleton: WebMessagingSkeleton;
    });
    /**
     * Registers the listener function
     *
     * @param listener a listener function that should be added and should receive messages
     */
    registerListener(listener: Function): void;
    /**
     * Unregisters the listener function
     *
     * @param listener the listener function that should re removed and shouldn't receive messages any more
     */
    unregisterListener(listener: Function): void;
    private webMessagingSkeletonListener;
}
export = BrowserMessagingSkeleton;
