"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const Typing = __importStar(require("../../util/Typing"));
const BrowserMessagingStub_1 = __importDefault(require("./BrowserMessagingStub"));
class BrowserMessagingStubFactory {
    /**
     * @constructor
     *
     * @param settings
     * @param settings.webMessagingStub an initialized sender that has the default window already set
     */
    constructor(settings) {
        Typing.checkProperty(settings, "Object", "settings");
        Typing.checkProperty(settings.webMessagingStub, "WebMessagingStub", "settings.webMessagingStub");
        this.webMessagingStub = settings.webMessagingStub;
    }
    /**
     * @param address the address to generate a messaging stub for
     */
    build(address) {
        return new BrowserMessagingStub_1.default({
            windowId: address.windowId,
            webMessagingStub: this.webMessagingStub
        });
    }
}
module.exports = BrowserMessagingStubFactory;
