"use strict";
class InProcessAddress {
    /**
     * @param inProcessMessagingSkeleton the skeleton that should be addressed in process
     */
    constructor(inProcessMessagingSkeleton) {
        this._typeName = "joynr.system.RoutingTypes.InProcessAddress";
        this.inProcessMessagingSkeleton = inProcessMessagingSkeleton;
    }
    /**
     * The receive function from the corresponding local messaging receiver
     *
     * @returns the skeleton that should be addressed
     */
    getSkeleton() {
        return this.inProcessMessagingSkeleton;
    }
    equals(other) {
        if (this === other) {
            return true;
        }
        if (other === undefined || other === null) {
            return false;
        }
        if (other._typeName === undefined || this._typeName !== other._typeName) {
            return false;
        }
        if (this.getSkeleton() !== other.getSkeleton()) {
            return false;
        }
        return true;
    }
}
InProcessAddress._typeName = "joynr.system.RoutingTypes.InProcessAddress";
module.exports = InProcessAddress;
