import MqttAddress from "../../../generated/joynr/system/RoutingTypes/MqttAddress";
import SharedMqttClient = require("./SharedMqttClient");
import MessageRouter = require("../routing/MessageRouter");
declare class MqttMessagingSkeleton {
    private client;
    private multicastSubscriptionCount;
    /**
     * @constructor MqttMessagingSkeleton
     * @param settings
     * @param settings.client the mqtt client to be used to transmit messages
     * @param settings.messageRouter the message router
     * @param settings.address own address of joynr client
     */
    constructor(settings: {
        client: SharedMqttClient;
        messageRouter: MessageRouter;
        address: MqttAddress;
    });
    private translateWildcard;
    registerMulticastSubscription(multicastId: string): void;
    unregisterMulticastSubscription(multicastId: string): void;
    shutdown(): void;
}
export = MqttMessagingSkeleton;
