import * as MqttAddress from "../../../generated/joynr/system/RoutingTypes/MqttAddress";
import JoynrMessage from "../JoynrMessage";
import SharedMqttClient = require("./SharedMqttClient");
declare class MqttMessagingStub {
    static PRIORITY_LOW: string;
    private address;
    private client;
    /**
     * @param settings the settings object for this constructor call
     * @param settings.address the mqtt address of the message destination
     * @param settings.client the mqtt client to be used to transmit messages
     */
    constructor(settings: {
        address: MqttAddress;
        client: SharedMqttClient;
    });
    /**
     * @param message the message to transmit
     */
    transmit(message: JoynrMessage): Promise<void>;
}
export = MqttMessagingStub;
