"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
const JoynrMessage_1 = __importDefault(require("../JoynrMessage"));
const JSONSerializer = __importStar(require("../../util/JSONSerializer"));
const LoggingManager_1 = __importDefault(require("../../system/LoggingManager"));
const log = LoggingManager_1.default.getLogger("joynr/messaging/mqtt/MqttMessagingStub");
class MqttMessagingStub {
    /**
     * @param settings the settings object for this constructor call
     * @param settings.address the mqtt address of the message destination
     * @param settings.client the mqtt client to be used to transmit messages
     */
    constructor(settings) {
        this.address = settings.address;
        this.client = settings.client;
    }
    /**
     * @param message the message to transmit
     */
    transmit(message) {
        log.debug(`transmit message: "${JSONSerializer.stringify(message)}"`);
        let topic = this.address.topic;
        if (!(JoynrMessage_1.default.JOYNRMESSAGE_TYPE_MULTICAST === message.type)) {
            topic += MqttMessagingStub.PRIORITY_LOW;
        }
        return this.client.send(topic, message);
    }
}
MqttMessagingStub.PRIORITY_LOW = "/low";
module.exports = MqttMessagingStub;
