"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
/*
 * #%L
 * %%
 * Copyright (C) 2019 BMW Car IT GmbH
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
const MqttAddress_1 = __importDefault(require("../../../generated/joynr/system/RoutingTypes/MqttAddress"));
class MqttMulticastAddressCalculator {
    /**
     * @constructor MqttMulticastAddressCalculator
     * @param settings
     * @param settings.globalAddress
     */
    constructor(settings) {
        this.globalAddress = settings.globalAddress;
    }
    /**
     * Calculates the multicast address for the submitted joynr message
     *
     * @param message
     * @returns the multicast address
     */
    calculate(message) {
        return new MqttAddress_1.default({
            brokerUri: this.globalAddress.brokerUri,
            topic: message.to
        });
    }
}
module.exports = MqttMulticastAddressCalculator;
