import mqtt from "mqtt";
import * as MqttAddress from "../../../generated/joynr/system/RoutingTypes/MqttAddress";
import JoynrMessage = require("../JoynrMessage");
declare class SharedMqttClient {
    static BEST_EFFORT_QOS_LEVEL: mqtt.QoS;
    static DEFAULT_QOS_LEVEL: mqtt.QoS;
    private queuedUnsubscriptions;
    private queuedSubscriptions;
    private qosLevel;
    private onConnectedDeferred;
    private connected;
    private closed;
    private queuedMessages;
    private onmessageCallback?;
    private address;
    private client;
    /**
     * @constructor
     * @param settings
     * @param settings.address to be used to connect to mqtt broker
     */
    constructor(settings: {
        address: MqttAddress;
        provisioning: {
            qosLevel?: mqtt.QoS;
        };
    });
    set onmessage(newCallback: Function);
    get onmessage(): Function;
    private onMessage;
    private onError;
    private resetConnection;
    onConnected(): Promise<any>;
    private sendQueuedUnsubscriptions;
    private sendQueuedMessages;
    private sendQueuedSubscriptions;
    private onOpen;
    /**
     * @param topic the topic to publish the message
     * @param joynrMessage the joynr message to transmit
     */
    send(topic: string, joynrMessage: JoynrMessage): Promise<any>;
    close(): void;
    subscribe(topic: string): void;
    unsubscribe(topic: string): void;
}
export = SharedMqttClient;
