import JoynrMessage = require("../JoynrMessage");
declare class ParticipantQueue {
    currentQueueSize: number;
    private queue;
    /**
     * This is a helper class for MessageQueue. It manages the messages waiting for a single participant.
     * It keeps its queue size which can be used by the messageQueue to calculate the total queue size of all participant
     * queues.
     * It allows queued messages to be filtered by expiry date.
     *
     * @constructor
     */
    constructor();
    /**
     * filters expired messages
     *
     */
    filterExpiredMessages(): void;
    /**
     * puts messages in queue
     *
     */
    putMessage(message: JoynrMessage, size: number): void;
    getMessages(): JoynrMessage[];
    getSize(): number;
}
export = ParticipantQueue;
