declare class WebMessagingAddress {
    private settings;
    /**
     * @constructor WebMessagingAddress
     * @param settings the settings object for this constructor call
     * @param settings.window the default target window, the messages should be sent to
     * @param settings.origin the default origin, the messages should be sent to
     */
    constructor(settings: {
        window: Window;
        origin: string;
    });
    /**
     * @returns the windows that should be addressed
     */
    getWindow(): Window;
    /**
     * @returns the origin of the window that should be addressed
     * @see WebMessagingAddress#getWindow
     */
    getOrigin(): string;
}
export = WebMessagingAddress;
