declare class WebMessagingSkeleton {
    private settings;
    private receiverCallbacks;
    /**
     * @constructor WebMessagingSkeleton
     * @param settings the settings object for this constructor call
     * @param settings.window the window to register the event handler at
     */
    constructor(settings: {
        window: Window;
    });
    callbackFct(event: any): void;
    /**
     * Registers a listener for web messaging
     *
     * @param listener the listener function receiving the messaging events events with the signature "function(joynrMessage) {..}"
     */
    registerListener(listener: Function): void;
    /**
     * Unregisters a listener for web messaging
     *
     * @param listener the listener function receiving the messaging events events with the signature "function(joynrMessage) {..}"
     */
    unregisterListener(listener: Function): void;
    shutdown(): void;
}
export = WebMessagingSkeleton;
