import JoynrMessage = require("../JoynrMessage");
declare class WebMessagingStub {
    private settings;
    /**
     * @constructor
     *
     * @param settings the settings object for this constructor call
     * @param settings.window the default target window, the messages should be sent to
     * @param settings.origin the default origin, the messages should be sent to
     */
    constructor(settings: {
        window: Record<string, any>;
        origin: string;
    });
    /**
     * @param message the message to transmit
     */
    transmit(message: {
        message: JoynrMessage;
        windowId?: string;
    }): Promise<void>;
}
export = WebMessagingStub;
