import SharedWebSocket = require("./SharedWebSocket");
declare class WebSocketMessagingSkeleton {
    private listener?;
    private sharedWebSocket;
    /**
     * @constructor WebSocketMessagingSkeleton
     * @param settings
     * @param settings.sharedWebSocket
     * @param settings.mainTransport
     */
    constructor(settings: {
        sharedWebSocket: SharedWebSocket;
        mainTransport: boolean;
    });
    /**
     * Registers the listener function
     *
     * @param listener a listener function that should be added and should receive messages
     */
    registerListener(listener: Function): void;
    /**
     * Unregisters the listener function
     *
     * @param _listener the listener function that should re removed and shouldn't receive
     *            messages any more
     */
    unregisterListener(_listener: Function): void;
    shutdown(): void;
}
export = WebSocketMessagingSkeleton;
