"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
/*eslint no-unused-vars: "off"*/
const Typing = __importStar(require("../../util/Typing"));
class WebSocketMulticastAddressCalculator {
    /**
     * @constructor WebSocketMulticastAddressCalculator
     * @param settings
     * @param settings.globalAddress
     */
    constructor(settings) {
        Typing.checkProperty(settings, "Object", "settings");
        Typing.checkProperty(settings.globalAddress, "WebSocketAddress", "settings.globalAddress");
        this.settings = settings;
    }
    /**
     * Calculates the multicast address for the submitted joynr message
     *
     * @param _message
     * @return the multicast address
     */
    calculate(_message) {
        return this.settings.globalAddress;
    }
}
module.exports = WebSocketMulticastAddressCalculator;
