import TypeRegistry from "../start/TypeRegistry";
interface JoynrProvider {
    new (...args: any[]): any;
    getUsedJoynrtypes(): any[];
}
declare class ProviderBuilder {
    /**
     * TypeRegistry used to register the joynr types.
     */
    private typeRegistry;
    constructor({ typeRegistry }: {
        typeRegistry: TypeRegistry;
    });
    /**
     * @param ProviderConstructor - the constructor function of the generated Provider that
     *            creates a new provider instance
     * @param implementation - an object containing the same fields and public functions as
     *            exposed int he provider that implements the actual functionaltiy of the
     *            provider
     * @returns a provider of the given type
     * @throws {Error} if correct implementation was not provided
     */
    build<T extends JoynrProvider, Impl>(ProviderConstructor: T, implementation: Impl): any;
}
export = ProviderBuilder;
