"use strict";
/*
 * #%L
 * %%
 * Copyright (C) 2019 BMW Car IT GmbH
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
class PlatformSecurityManager {
    /**
     * @returns the user ID that executes node
     */
    getCurrentProcessUserId() {
        // Remark: Faking the user name by setting this environment variable
        // is not a security threat, since the process can only access the
        // private key of the real user. This key is used to sign the message.
        // On the receiving side joynr will try to verify the message signature
        // with the public key of the faked user which will fail.
        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
        return process.env.USER;
    }
}
module.exports = PlatformSecurityManager;
