"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
/*
 * #%L
 * %%
 * Copyright (C) 2019 BMW Car IT GmbH
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
const ProviderQos = require("../../../generated/joynr/types/ProviderQos");
const GlobalDiscoveryEntry_1 = __importDefault(require("../../../generated/joynr/types/GlobalDiscoveryEntry"));
const ProviderScope_1 = __importDefault(require("../../../generated/joynr/types/ProviderScope"));
const Version = require("../../../generated/joynr/types/Version");
const UtilInternal = __importStar(require("../../util/UtilInternal"));
const GlobalCapabilitiesDirectoryProvider_1 = __importDefault(require("../../../generated/joynr/infrastructure/GlobalCapabilitiesDirectoryProvider"));
module.exports = function (settings) {
    const discoveryChannel = "discoverydirectory_channelid";
    const defaultSettings = {
        discoveryChannel,
        getDefaultDiscoveryChannelUrl: () => {
            return `${settings.bounceProxyBaseUrl}/discovery/channels/${defaultSettings.discoveryChannel}/`;
        },
        capabilities: [
            new GlobalDiscoveryEntry_1.default({
                providerVersion: new Version({
                    majorVersion: GlobalCapabilitiesDirectoryProvider_1.default.MAJOR_VERSION,
                    minorVersion: GlobalCapabilitiesDirectoryProvider_1.default.MINOR_VERSION
                }),
                domain: "io.joynr",
                interfaceName: "infrastructure/GlobalCapabilitiesDirectory",
                participantId: "capabilitiesdirectory_participantid",
                qos: new ProviderQos({
                    customParameters: [],
                    priority: 1,
                    scope: ProviderScope_1.default.GLOBAL,
                    supportsOnChangeSubscriptions: true
                }),
                lastSeenDateMs: Date.now(),
                expiryDateMs: UtilInternal.getMaxLongValue(),
                publicKeyId: "",
                address: JSON.stringify({
                    _typeName: "joynr.system.RoutingTypes.MqttAddress",
                    topic: discoveryChannel,
                    brokerUri: settings.brokerUri
                })
            })
        ],
        gbids: ["joynrdefaultgbid"]
    };
    return defaultSettings;
};
