"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
const ProviderQos_1 = __importDefault(require("../../../generated/joynr/types/ProviderQos"));
const ProviderScope_1 = __importDefault(require("../../../generated/joynr/types/ProviderScope"));
const UtilInternal = __importStar(require("../../util/UtilInternal"));
const RoutingProvider_1 = __importDefault(require("../../../generated/joynr/system/RoutingProvider"));
const DiscoveryProvider_1 = __importDefault(require("../../../generated/joynr/system/DiscoveryProvider"));
const Version = require("../../../generated/joynr/types/Version");
const discoveryCapability = {
    providerVersion: new Version({
        majorVersion: DiscoveryProvider_1.default.MAJOR_VERSION,
        minorVersion: DiscoveryProvider_1.default.MINOR_VERSION
    }),
    domain: "io.joynr",
    interfaceName: "system/Discovery",
    participantId: "CC.DiscoveryProvider.ParticipantId",
    qos: new ProviderQos_1.default({
        customParameters: [],
        priority: 1,
        scope: ProviderScope_1.default.LOCAL,
        supportsOnChangeSubscriptions: true
    }),
    lastSeenDateMs: Date.now(),
    expiryDateMs: UtilInternal.getMaxLongValue(),
    publicKeyId: "",
    isLocal: true
};
const routingCapability = {
    providerVersion: new Version({
        majorVersion: RoutingProvider_1.default.MAJOR_VERSION,
        minorVersion: RoutingProvider_1.default.MINOR_VERSION
    }),
    domain: "io.joynr",
    interfaceName: "system/Routing",
    participantId: "CC.RoutingProvider.ParticipantId",
    qos: new ProviderQos_1.default({
        customParameters: [],
        priority: 1,
        scope: ProviderScope_1.default.LOCAL,
        supportsOnChangeSubscriptions: true
    }),
    lastSeenDateMs: Date.now(),
    expiryDateMs: UtilInternal.getMaxLongValue(),
    publicKeyId: "",
    isLocal: true
};
const capabilities = [discoveryCapability, routingCapability];
const defaultLibJoynrSettings = {
    capabilities,
    shutdownSettings: {
        clearSubscriptionsEnabled: true,
        clearSubscriptionsTimeoutMs: 1000
    },
    persistencySettings: {
        capabilities: true
    }
};
module.exports = defaultLibJoynrSettings;
