import { Logging } from "../start/interface/Provisioning";
import JoynrLogger from "./JoynrLogger";
declare class LoggingManager {
    readonly LogLevel: Record<string, import("./JoynrLogger").LogLevel>;
    reset(): void;
    /**
     * @param name - the name of the logger
     *
     * @returns a new Instance of JoynrLogger with the respective name.
     */
    getLogger(name: string): JoynrLogger;
    /**
     * configure takes a configuration object that conforms to a subset of the log4j2
     * json configuration
     *
     * @param settings - log4j2-style JSON config, but as JavaScript object
     *            (i.e. already parsed)
     */
    configure(settings: Logging): void;
    registerForLogLevelChanged(callback: Function): void;
}
declare type loggingManager = LoggingManager;
declare const loggingManager: LoggingManager;
export = loggingManager;
