import * as DiscoveryEntryWithMetaInfo from "../../generated/joynr/types/DiscoveryEntryWithMetaInfo";
/**
 * The ArbitrationStrategyCollection.Nothing just returns the passed array
 *
 * @param capabilities the array of capability entries
 * @param capabilities.array the array of DiscoveryEntries
 *
 * @returns an array of capabilities as it came in through the
 *          capabilities parameter
 */
export declare function Nothing(capabilities: DiscoveryEntryWithMetaInfo[]): DiscoveryEntryWithMetaInfo[];
/**
 * The ArbitrationStrategyCollection.HighestPriority favors higher priorities
 *
 * @param capabilities the array of capability entries
 *
 * @returns an array of capabilities sorted by the highest priority
 */
export declare function HighestPriority(capabilities: DiscoveryEntryWithMetaInfo[]): DiscoveryEntryWithMetaInfo[];
/**
 * The ArbitrationStrategyCollection.Keyword searches for the given keyword in the
 * "keyword" qos parameter and returns those.
 * NOTE: to use this function, you must bind your keyword as follows:
 * arbitrationStrategy = Keyword.bind(undefined, "myKeyword")
 *
 * @param capabilities the array of capability entries
 * @param keyword the keyword to search for
 * @returns an array of capabilities sorted by the highest priority
 */
export declare function Keyword(keyword: string, capabilities: DiscoveryEntryWithMetaInfo[]): DiscoveryEntryWithMetaInfo[];
/**
 * The ArbitrationStrategyCollection.LastSeen favors latest lastSeenDateMs
 *
 * @param capabilities the array of capability entries
 * @param capabilities.array the array of capability entries
 *
 * @returns an array of capabilities sorted by the lastSeenDateMs
 */
export declare function LastSeen(capabilities: DiscoveryEntryWithMetaInfo[]): DiscoveryEntryWithMetaInfo[];
/**
 * The ArbitrationStrategyCollection.FixedParticipant returns an array of one entry with the FixedParticipantId
 *
 * @param capabilities the array of capability entries
 * @param capabilities.array the array of capability entries
 *
 * @returns an array of one and solely capability which is the one of FixedParticipantId
 */
export declare function FixedParticipant(capabilities: DiscoveryEntryWithMetaInfo[]): DiscoveryEntryWithMetaInfo[];
