"use strict";
/*
 * #%L
 * %%
 * Copyright (C) 2019 BMW Car IT GmbH
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
/* istanbul ignore file */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
const JoynrObject_1 = __importDefault(require("./JoynrObject"));
class JoynrMap extends JoynrObject_1.default {
    constructor(settings) {
        super();
        if (settings !== undefined) {
            for (const settingKey in settings) {
                if (Object.prototype.hasOwnProperty.call(settings, settingKey)) {
                    // @ts-ignore
                    this[settingKey] = settings[settingKey];
                }
            }
        }
    }
    put(key, value) {
        // @ts-ignore
        this[key] = value;
    }
    get(key) {
        // @ts-ignore
        return this[key];
    }
    remove(key) {
        // @ts-ignore
        delete this[key];
    }
}
module.exports = JoynrMap;
