import JoynrObject from "./JoynrObject";
export interface ProviderReadAttributeImpl<T> {
    get: () => T | Promise<T>;
}
export interface ProviderWriteAttributeImpl<T> {
    set: (value: T) => void;
}
export interface ProviderNotifyAttributeImpl<T> {
    valueChanged: (value: T) => void;
}
export declare type ProviderReadWriteAttributeImpl<T> = ProviderReadAttributeImpl<T> & ProviderWriteAttributeImpl<T>;
export declare type ProviderReadNotifyAttributeImpl<T> = ProviderReadAttributeImpl<T> & ProviderNotifyAttributeImpl<T>;
export declare type ProviderReadWriteNotifyAttributeImpl<T> = ProviderReadAttributeImpl<T> & ProviderWriteAttributeImpl<T> & ProviderNotifyAttributeImpl<T>;
export declare abstract class JoynrProvider extends JoynrObject {
    abstract interfaceName: string;
    protected constructor();
    checkImplementation(): string[];
}
export interface JoynrProviderType extends Function {
    new (...args: any[]): JoynrProvider;
    MAJOR_VERSION: number;
    MINOR_VERSION: number;
    getUsedJoynrtypes: any[];
}
