"use strict";
/*
 * #%L
 * %%
 * Copyright (C) 2019 BMW Car IT GmbH
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * #L%
 */
/* istanbul ignore file */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const JoynrObject_1 = __importDefault(require("./JoynrObject"));
const ProviderAttribute_1 = require("../provider/ProviderAttribute");
const ProviderOperation_1 = __importDefault(require("../provider/ProviderOperation"));
class JoynrProvider extends JoynrObject_1.default {
    constructor() {
        super();
    }
    checkImplementation() {
        const missingInImplementation = [];
        Object.values(this).forEach(elem => {
            if (elem instanceof ProviderAttribute_1.ProviderAttribute) {
                if (!elem.check()) {
                    missingInImplementation.push(elem.attributeName);
                }
            }
            if (elem instanceof ProviderOperation_1.default) {
                if (!elem.checkOperation()) {
                    missingInImplementation.push(elem.operationName);
                }
            }
        });
        return missingInImplementation;
    }
}
exports.JoynrProvider = JoynrProvider;
