import TypeRegistry from "../start/TypeRegistry";
declare class TypeRegistrySingleton {
    /**
     * forward addType call to the TypeRegistry instance
     * @function TypeRegistrySingleton#addType
     */
    static addType: TypeRegistry["addType"];
    /**
     * A singleton Implementation for the Type Registry.
     *
     * Cannot be instantiated.
     *
     * @constructor
     * @throws {Error} Can not instantiate this type
     */
    constructor();
    /**
     * @returns the TypeRegistry singleton instance
     */
    static getInstance(): TypeRegistry;
}
export = TypeRegistrySingleton;
