import MessagingQos from "./joynr/messaging/MessagingQos";
import PeriodicSubscriptionQos from "./joynr/proxy/PeriodicSubscriptionQos";
import OnChangeSubscriptionQos from "./joynr/proxy/OnChangeSubscriptionQos";
import MulticastSubscriptionQos from "./joynr/proxy/MulticastSubscriptionQos";
import OnChangeWithKeepAliveSubscriptionQos from "./joynr/proxy/OnChangeWithKeepAliveSubscriptionQos";
import BroadcastFilterParameters from "./joynr/proxy/BroadcastFilterParameters";
import * as ArbitrationStrategyCollection from "./joynr/types/ArbitrationStrategyCollection";
import * as Util from "./joynr/util/Util";
import JoynrException from "./joynr/exceptions/JoynrException";
import JoynrRuntimeException from "./joynr/exceptions/JoynrRuntimeException";
import ApplicationException from "./joynr/exceptions/ApplicationException";
import DiscoveryException from "./joynr/exceptions/DiscoveryException";
import IllegalAccessException from "./joynr/exceptions/IllegalAccessException";
import MethodInvocationException from "./joynr/exceptions/MethodInvocationException";
import NoCompatibleProviderFoundException from "./joynr/exceptions/NoCompatibleProviderFoundException";
import ProviderRuntimeException from "./joynr/exceptions/ProviderRuntimeException";
import PublicationMissedException from "./joynr/exceptions/PublicationMissedException";
import SubscriptionException from "./joynr/exceptions/SubscriptionException";
import ProviderQos from "./generated/joynr/types/ProviderQos";
import ProviderScope from "./generated/joynr/types/ProviderScope";
import CustomParameter from "./generated/joynr/types/CustomParameter";
import DiscoveryQos from "./joynr/proxy/DiscoveryQos";
import DiscoveryScope from "./generated/joynr/types/DiscoveryScope";
import BrowserAddress from "./generated/joynr/system/RoutingTypes/BrowserAddress";
import ChannelAddress from "./generated/joynr/system/RoutingTypes/ChannelAddress";
import WebSocketAddress from "./generated/joynr/system/RoutingTypes/WebSocketAddress";
import WebSocketClientAddress from "./generated/joynr/system/RoutingTypes/WebSocketClientAddress";
import LongTimer from "./joynr/util/LongTimer";
declare class JoynrApi {
    constructor();
    buildSignature: string;
    messaging: {
        MessagingQos: typeof MessagingQos;
    };
    proxy: {
        PeriodicSubscriptionQos: typeof PeriodicSubscriptionQos;
        OnChangeSubscriptionQos: typeof OnChangeSubscriptionQos;
        MulticastSubscriptionQos: typeof MulticastSubscriptionQos;
        OnChangeWithKeepAliveSubscriptionQos: typeof OnChangeWithKeepAliveSubscriptionQos;
        BroadcastFilterParameters: typeof BroadcastFilterParameters;
        DiscoveryQos: typeof DiscoveryQos;
    };
    types: {
        ArbitrationStrategyCollection: typeof ArbitrationStrategyCollection;
        ProviderQos: typeof ProviderQos;
        ProviderScope: typeof ProviderScope;
        CustomParameter: typeof CustomParameter;
        DiscoveryScope: typeof DiscoveryScope;
    };
    util: {
        LongTimer: LongTimer;
        Util: typeof Util;
    };
    exceptions: {
        JoynrException: typeof JoynrException;
        JoynrRuntimeException: typeof JoynrRuntimeException;
        ApplicationException: typeof ApplicationException;
        DiscoveryException: typeof DiscoveryException;
        IllegalAccessException: typeof IllegalAccessException;
        MethodInvocationException: typeof MethodInvocationException;
        NoCompatibleProviderFoundException: typeof NoCompatibleProviderFoundException;
        ProviderRuntimeException: typeof ProviderRuntimeException;
        PublicationMissedException: typeof PublicationMissedException;
        SubscriptionException: typeof SubscriptionException;
    };
    system: {
        RoutingTypes: {
            BrowserAddress: typeof BrowserAddress;
            ChannelAddress: typeof ChannelAddress;
            WebSocketAddress: typeof WebSocketAddress;
            WebSocketClientAddress: typeof WebSocketClientAddress;
        };
    };
}
export = JoynrApi;
